;**************************************************************************
;******** KK  KK RRRRR   OOOO  KK  KK  OOOO  MM   MM EEEEEE RRRRR  ********
;******** KK KK  RR  RR OO  OO KK KK  OO  OO MMM MMM EE     RR  RR ********
;******** KKKK   RRRRR  OO  OO KKKK   OO  OO MM M MM EEEE   RRRRR  ********
;******** KK KK  RR RR  OO  OO KK KK  OO  OO MM   MM EE     RR RR  ********
;******** KK  KK RR  RR  OOOO  KK  KK  OOOO  MM   MM EEEEEE RR  RR ********
;**************************************************************************
;***** Digitalni krokomer s cidlem ADXL202 pro mereni usle vzdalenosti ****
;**************************************************************************
;******** Vypracoval: Radek Zeman                                  ********
;******** Pouzite obvody: AT89C52, ADXL202, MAX1724, MC0802        ********
;**************************************************************************

$MOD52
$NOPAGING

DATA_Y		BIT	P3.2	;INT0, vstup dataX
DB7             BIT     P1.7    ;Data display DB7
DB6             BIT     P1.6    ;Data display DB6
DB5             BIT     P1.5    ;Data display DB5
DB4             BIT     P1.4    ;Data display DB4
RES             BIT     P1.3    ;Data display RESET
R_W             BIT     P1.2    ;Data display READ/WRITE
ENA             BIT     P1.1    ;Data display ENABLE (CLOCK)
EE_DAT		BIT	P2.0	;Seriova data EEPROM
EE_CLK		BIT	P2.1	;Seriove clock EEPROM
SPINAC_T	BIT	P2.7	;Bit urcujici zasunuti JACKu, 0=sep, 1=nesep
TLAC1		BIT	P2.4	;Tlacitko 1
TLAC2		BIT	P2.2	;Tlacitko 2
TLAC3		BIT	P2.3	;Tlacitko 3
DRZ		BIT	P2.5	;Abych mohl vypnout napajeni DRZ=1=>funguje
PIP		BIT	P1.0	;Pripojene pipadlo
;---------------------------------------------------------------------------
STAV_KROK	BIT	021h	;Stav ve vysilani, je novy krok? 0=NE, 1=ANO
BEZI_USART	BIT	022h	;Jestli uz bezi USART 0=NE, 1=ANO
ZNAMENKO	BIT	023h	;Znamenko na zrychleni (A)
ZRUSIT          BIT     024h    ;Stavovy bit pro TLAC1
SIPKA           BIT     025h    ;Stavovy bit pro TLAC2
ENTER           BIT     026h    ;Stavovy bit pro TLAC3
TEMP_B          BIT     027h    ;Pomocny bit
VRCHOL          BIT     028h    ;Zda jsem byl na vrcholu, nebo ne
Z_ZNAMENKO      BIT     029h    ;Znamenko na zrychleni (A) => UART

	DSEG			;Datovy segment
	org 0030h		;Zacatek datove RAM

VYSL_1:         DS      1h      ;Pomocny registr pro vypocty
VYSL_2:         DS      1h      ;Pomocny registr pro vypocty
VYSL_3:         DS      1h      ;Pomocny registr pro vypocty
VYSL_4:         DS      1h      ;Pomocny registr pro vypocty
CELA_CAST:	DS	1h	;Cela cast (A)
DESETC_L:	DS	1h	;Desetine cislo (A - L)
DESETC_H:	DS	1h	;Desetine cislo (A - H)
POCET_C:        DS      1h      ;Neprimo udava desetina cisla
DES_C:		DS	1h	;Jestli jem v cele nebo desetine casti
X_POSUN:        DS      1h      ;Nasobici konstanta ADXL202 (125)
O_POSUN:        DS      1h      ;Pozice 0G ADXL202, priblizne (50)
DTXL_T1:        DS      1h      ;Delka 8 nizsich b. useku T1-zrychleni
DTXH_T1:        DS      1h      ;Delka 8 vyssich b. useku T1-zrychleni
DTXL_T2:        DS      1h      ;Delka 8 nizsich b. useku T2-perioda
DTXH_T2:        DS      1h      ;Delka 8 vyssich b. useku T2-perioda
CAS_1L:         DS      1h      ;Pomocny registr pro PAUZU (L)
CAS_1H:         DS      1h      ;Pomocny registr pro PAUZU (H)
TEMP1:          DS      1h      ;Pomocny registr TEMP1
TEMP2:		DS	1h	;Pomocny registr TEMP2
O_DESETC_H:	DS	1h	;Urcuje nultou hladinu H
O_DESETC_L:	DS	1h	;Urcuje nultou hladinu L
N_DESETC_H:	DS	1h	;Nova data po klouzavem prumeru H
N_DESETC_L:	DS	1h	;Nova data po klouzavem prumeru L
S_DESETC_H:	DS	1h	;Stara data pro zjisteni vrcholu H
S_DESETC_L:	DS	1h	;Stara data pro zjisteni vrcholu L
VELIKOST_D:	DS	1h	;Definuje velikost klouzaveho prumeru
KONEC_PO:	DS	1h	;Pouziva se pri klouzavem prumeru
P_KROK_H:	DS	1h	;Udava pocet kroku H
P_KROK_M:	DS	1h	;Udava pocet kroku M
P_KROK_L:	DS	1h	;Udava pocet kroku L
D_TRASY_H:	DS	1h	;Udava delku trasy H
D_TRASY_M:	DS	1h	;Udava delku trasy M
D_TRASY_L:	DS	1h	;Udava delku trasy L
D_KROKU:	DS	1h	;Urcuje delku kroku
ZRY_LT1:        DS      1h      ;Prechova dat
ZRY_HT1:        DS      1h      ;Prechova dat
ZRY_LT2:        DS      1h      ;Prechova dat
ZRY_HT2:        DS      1h      ;Prechova dat
NASTA_SV:       DS      1h      ;Nastaveni serioveho portu
DATA_Z:         DS      1h      ;Data pro zobrazeni 3
CO:             DS      1h      ;Co budu vysilat
Z_CELA_CAST:    DS      1h      ;Cela cast (A) => UART
Z_DESETC_L:     DS      1h      ;Desetine cislo (A - L) => UART
Z_DESETC_H:     DS      1h      ;Desetine cislo (A - H) => UART

;--------------------------------------------------------------------------

	CSEG				;Programovy segment
	org	0000h			;Hned po resetu
        ljmp    MAIN                    ;Skoc na MAIN

	org	0003h			;INT0
	lcall	PRERUS_INT0		;Zavolej PRERUS_INTO
	RETI				;Navrat z preruseni

        org     0023h                   ;USART
        lcall   USART                   ;Zavolej USART
        RETI                            ;Navrat z preruseni

;---------------------------------------------------------------------------
	org	0030h			;Zacatek programu
MAIN:
	mov	IE,#00000000b		;Zakazane vsechny preruseni

        mov     R1,#20d                 ;R1 pocet opakovani 1s  -----  
        lcall   PAUZA                   ;Zavolej pauzu               |Je 
        clr     DRZ                     ;Drz napajeni                |zapnut
        lcall   BEEP                    ;Pipej   --------------------

        mov     SP,#08h                 ;Nastaveni zasobniku na R0-2
        
CEKEJ_NA_0:
	jb	DATA_Y,CEKEJ_NA_0	;Jestli je INT0=1 => CEKEJ
					;INTO=0
	mov	TCON,#00000101b		;Sestupna hrana INT0
        mov     TMOD,#00001001b         ;Citac T0=>GATE,16bit
	setb	TR0			;Stusti T0
	mov	IE,#10000001b		;EA, INT0 povoleno preruseni
        mov     TL0,#0h                 ;Vynuluj registr TL0
	mov	TH0,#0h			;Vynuluj registr TH0

;---------------------------------------------------------------------------
;---------------------------------------------------------------------------
        lcall   D_INIT                  ;       ------------------
					;			  |
	clr	RES			;			  |
	clr	R_W			;			  |Iniciace
	mov	R0,#00101000b		;2radky,5x8bodu		  |displeje
        lcall   D_COMMAND               ;                         |=> 4bit
					;			  |
	mov	R0,#00001100b		;zapni, no kurzor	  |
        lcall   D_COMMAND               ;                         |
					;			  |
	mov	R0,#00000110b		;no shift, inc pozici	  |	
        lcall   D_COMMAND               ;       ------------------
;---------------------------------------
        clr     RES                     ;       ------------------
        clr     R_W                     ;                         |
        mov     R0,#01000000b           ;CGRAM pozice 0           |
        lcall   D_COMMAND               ;                         |
                                        ;                         |
        setb    RES                     ;                         |
        mov     R0,#00000010b           ;1radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00000100b           ;2radek                   |Definice
        lcall   D_COMMAND               ;                         |pismena
        mov     R0,#00001110b           ;3radek                   |______
        lcall   D_COMMAND               ;                         |dlouhe e
        mov     R0,#00010001b           ;4radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00011111b           ;5radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00010000b           ;6radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00001110b           ;7radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00000000b           ;8radek                   |
        lcall   D_COMMAND               ;       ------------------                         
;---------------------------------------
        clr     RES                     ;       ------------------
        clr     R_W                     ;                         |
        mov     R0,#01001000b           ;CGRAM pozice 1           |
        lcall   D_COMMAND               ;                         |
                                        ;                         |
        setb    RES                     ;                         |
        mov     R0,#00000001b           ;1radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00000010b           ;2radek                   |Definice
        lcall   D_COMMAND               ;                         |pismena
        mov     R0,#00000100b           ;3radek                   |______
        lcall   D_COMMAND               ;                         |dlouhe i
        mov     R0,#00001100b           ;4radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00000100b           ;5radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00000100b           ;6radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00001110b           ;7radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00000000b           ;8radek                   |
        lcall   D_COMMAND               ;       ------------------
;---------------------------------------
        clr     RES                     ;       ------------------
        clr     R_W                     ;                         |
        mov     R0,#01010000b           ;CGRAM pozice 2           |
        lcall   D_COMMAND               ;                         |
                                        ;                         |
        setb    RES                     ;                         |
        mov     R0,#00000010b           ;1radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00000100b           ;2radek                   |Definice
        lcall   D_COMMAND               ;                         |pismena
        mov     R0,#00001110b           ;3radek                   |______
        lcall   D_COMMAND               ;                         |dlouhe a
        mov     R0,#00000001b           ;4radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00001111b           ;5radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00010001b           ;6radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00001111b           ;7radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00000000b           ;8radek                   |
        lcall   D_COMMAND               ;       ------------------                         
;---------------------------------------
        clr     RES                     ;       ------------------
        clr     R_W                     ;                         |
        mov     R0,#01011000b           ;CGRAM pozice 3           |
        lcall   D_COMMAND               ;                         |
                                        ;                         |
        setb    RES                     ;                         |
        mov     R0,#00001010b           ;1radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00000100b           ;2radek                   |Definice
        lcall   D_COMMAND               ;                         |pismena
        mov     R0,#00011111b           ;3radek                   |______
        lcall   D_COMMAND               ;                         |z + car.
        mov     R0,#00000010b           ;4radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00000100b           ;5radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00001000b           ;6radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00011111b           ;7radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00000000b           ;8radek                   |
        lcall   D_COMMAND               ;       ------------------                         
;---------------------------------------
        clr     RES                     ;       ------------------
        clr     R_W                     ;                         |
        mov     R0,#01100000b           ;CGRAM pozice 4           |
        lcall   D_COMMAND               ;                         |
                                        ;                         |
        setb    RES                     ;                         |
        mov     R0,#00000010b           ;1radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00000110b           ;2radek                   |Definice
        lcall   D_COMMAND               ;                         |znaku
        mov     R0,#00001111b           ;3radek                   |sipka
        lcall   D_COMMAND               ;                         |1 cast
        mov     R0,#00011111b           ;4radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00001111b           ;5radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00000110b           ;6radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00000010b           ;7radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00000000b           ;8radek                   |
        lcall   D_COMMAND               ;       ------------------                         
;---------------------------------------
        clr     RES                     ;       ------------------
        clr     R_W                     ;                         |
        mov     R0,#01101000b           ;CGRAM pozice 5           |
        lcall   D_COMMAND               ;                         |
                                        ;                         |
        setb    RES                     ;                         |
        mov     R0,#00000000b           ;1radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00000000b           ;2radek                   |Definice
        lcall   D_COMMAND               ;                         |znaku
        mov     R0,#00011110b           ;3radek                   |sipka
        lcall   D_COMMAND               ;                         |2 cast
        mov     R0,#00011110b           ;4radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00011110b           ;5radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00000000b           ;6radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00000000b           ;7radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00000000b           ;8radek                   |
        lcall   D_COMMAND               ;       ------------------                         
;---------------------------------------
        clr     RES                     ;       ------------------
        clr     R_W                     ;                         |
        mov     R0,#01110000b           ;CGRAM pozice 6           |
        lcall   D_COMMAND               ;                         |
                                        ;                         |
        setb    RES                     ;                         |
        mov     R0,#00001010b           ;1radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00000100b           ;2radek                   |Definice
        lcall   D_COMMAND               ;                         |pismena
        mov     R0,#00001110b           ;3radek                   |______
        lcall   D_COMMAND               ;                         |e + hac.
        mov     R0,#00010001b           ;4radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00011111b           ;5radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00010000b           ;6radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00001110b           ;7radek                   |
        lcall   D_COMMAND               ;                         |
        mov     R0,#00000000b           ;8radek                   |
        lcall   D_COMMAND               ;       ------------------

;---------------------------------------
	clr	RES
	clr	R_W
	mov	R0,#10000000b		;Return home 0h=DDRAM
        lcall   D_COMMAND

;---------------------------------------
	mov	R0,#128d		;R0=128d	----------
	mov	R1,#80h			;R1=80h			  |Vynulov.
NULUJ_N_A:				;			  |neprim.
	mov	@R1,#0h			;Vynuluj na adrese @R1	  |adresov.
	inc	R1			;Zvys adresu		  |bytu
	djnz	R0,NULUJ_N_A		;Neni konec => skoc  -----

;---------------------------------------
	clr	STAV_KROK		;Smaz STAV_KROK=ze nejsou nova data
	clr	BEZI_USART		;Smaz BEZI_USART=jeste nebezi USART
        mov     CO,#4d                  ;Zacni vysilat 0

        mov     O_DESETC_H,#04h         ;1150d=> Urcuje hladinu necitlivosti
        mov     O_DESETC_L,#7Eh         ;
        mov     VELIKOST_D,#8d          ;8d=> Vazeny prumer o velikosti 8

;---------------------------------------
        lcall   E_START                 ;Start
        mov     R0,#10100000b           ;Adresa+W
        lcall   E_ADR_DAT               ;Posli
        lcall   E_ACK                   ;Ack
        mov     R0,#00000000b           ;AdresaP
        lcall   E_ADR_DAT               ;Posli
        lcall   E_ACK                   ;Ack
        lcall   E_START                 ;Start
        mov     R0,#10100001b           ;Adresa+R
        lcall   E_ADR_DAT               ;Posli
        lcall   E_ACK                   ;Ack
        lcall   E_READ                  ;Cti data    ------------- 
        mov     X_POSUN,R0              ;X_POSUN=R0               |X_POSUN
        lcall   E_NACK                  ;Nack                     |0
        lcall   E_STOP                  ;Stop      ---------------
        
        lcall   E_START                 ;Start
        mov     R0,#10100001b           ;Adresa+R
        lcall   E_ADR_DAT               ;Posli
        lcall   E_ACK                   ;Ack
        lcall   E_READ                  ;Cti data    ------------- 
        mov     O_POSUN,R0              ;O_POSUN=R0               |O_POSUN
        lcall   E_NACK                  ;Nack                     |1
        lcall   E_STOP                  ;Stop      ---------------

        lcall   E_START                 ;Start
        mov     R0,#10100001b           ;Adresa+R
        lcall   E_ADR_DAT               ;Posli
        lcall   E_ACK                   ;Ack
        lcall   E_READ                  ;Cti data    ------------- 
        mov     D_KROKU,R0              ;D_KROKU=R0               |D_KROKU
        lcall   E_NACK                  ;Nack                     |2
        lcall   E_STOP                  ;Stop      ---------------

        lcall   E_START                 ;Start
        mov     R0,#10100001b           ;Adresa+R
        lcall   E_ADR_DAT               ;Posli
        lcall   E_ACK                   ;Ack
        lcall   E_READ                  ;Cti data    ------------- 
        mov     NASTA_SV,R0             ;NASTA_SV=R0              |NASTA_SV
        lcall   E_NACK                  ;Nack                     |3
        lcall   E_STOP                  ;Stop      ---------------

        lcall   E_START                 ;Start
        mov     R0,#10100001b           ;Adresa+R
        lcall   E_ADR_DAT               ;Posli
        lcall   E_ACK                   ;Ack
        lcall   E_READ                  ;Cti data    ------------- 
        mov     P_KROK_H,R0             ;P_KROK_H=R0              |P_KROK_H
        lcall   E_NACK                  ;Nack                     |4
        lcall   E_STOP                  ;Stop      ---------------

        lcall   E_START                 ;Start
        mov     R0,#10100001b           ;Adresa+R
        lcall   E_ADR_DAT               ;Posli
        lcall   E_ACK                   ;Ack
        lcall   E_READ                  ;Cti data    ------------- 
        mov     P_KROK_M,R0             ;P_KROK_M=R0              |P_KROK_M
        lcall   E_NACK                  ;Nack                     |5
        lcall   E_STOP                  ;Stop      ---------------

        lcall   E_START                 ;Start
        mov     R0,#10100001b           ;Adresa+R
        lcall   E_ADR_DAT               ;Posli
        lcall   E_ACK                   ;Ack
        lcall   E_READ                  ;Cti data    ------------- 
        mov     P_KROK_L,R0             ;P_KROK_L=R0              |P_KROK_L
        lcall   E_NACK                  ;Nack                     |6
        lcall   E_STOP                  ;Stop      ---------------

        lcall   E_START                 ;Start
        mov     R0,#10100001b           ;Adresa+R
        lcall   E_ADR_DAT               ;Posli
        lcall   E_ACK                   ;Ack
        lcall   E_READ                  ;Cti data    ------------- 
        mov     D_TRASY_H,R0            ;D_TRASY_H=R0             |D_TRASY_H
        lcall   E_NACK                  ;Nack                     |7
        lcall   E_STOP                  ;Stop      ---------------

        ;Jina stranka EEPROM

        lcall   E_START                 ;Start
        mov     R0,#10100000b           ;Adresa+W
        lcall   E_ADR_DAT               ;Posli
        lcall   E_ACK                   ;Ack
        mov     R0,#00001000b           ;AdresaP
        lcall   E_ADR_DAT               ;Posli
        lcall   E_ACK                   ;Ack
        lcall   E_START                 ;Start
        mov     R0,#10100001b           ;Adresa+R
        lcall   E_ADR_DAT               ;Posli
        lcall   E_ACK                   ;Ack
        lcall   E_READ                  ;Cti data    ------------- 
        mov     D_TRASY_M,R0            ;D_TRASY_M=R0             |D_TRASY_M
        lcall   E_NACK                  ;Nack                     |8
        lcall   E_STOP                  ;Stop      ---------------
        
        lcall   E_START                 ;Start
        mov     R0,#10100001b           ;Adresa+R
        lcall   E_ADR_DAT               ;Posli
        lcall   E_ACK                   ;Ack
        lcall   E_READ                  ;Cti data    ------------- 
        mov     D_TRASY_L,R0            ;D_TRASY_L=R0             |D_TRASY_L
        lcall   E_NACK                  ;Nack                     |9
        lcall   E_STOP                  ;Stop      ---------------

;---------------------------------------
;---------------------------------------------------------------------------
;---------------------------------------------------------------------------
;---------------------------------------------------------------------------
M_ZOBRAZ:
        mov     R2,#00d                 ;Zobraz
        lcall   D_MENU                  ;Zobraz na display
M_ZOB1:
        lcall   TLACITKA                ;Zavolej tlacitka
        mov     R1,#2d                  ;R1 pocet opakovani 0.1s
        lcall   PAUZA                   ;Zavolej pauzu
        jnb     SIPKA,MZ1               ;Test na sipku
        ljmp    M_NASTAV                ;SIPKA=>M_NASTAV
MZ1:    jnb     ENTER,MZ2               ;Test na enter
        clr     VRCHOL                  ;Nebyl jsem na vrcholu
        ljmp    M_TRASA                 ;ENTER=>M_TRASA
MZ2:                                    ;ZRUSIT=>NIC
        ljmp    M_ZOB1                  ;Jinak cekej

;---------------------------------------
M_NASTAV:
        mov     R2,#80d                 ;Nastav
        lcall   D_MENU                  ;Zobraz na display
M_NAS1:
        lcall   TLACITKA                ;Zavolej tlacitka
        mov     R1,#2d                  ;R1 pocet opakovani 0.1s
        lcall   PAUZA                   ;Zavolej pauzu
        jnb     SIPKA,MM1               ;Test na sipku
        ljmp    M_INFO                  ;SIPKA=>M_INFO
MM1:    jnb     ENTER,MM2               ;Test na enter
        ljmp    M_DELKA_KROKU           ;ENTER=>M_DELKA_KROKU
MM2:                                    ;ZRUSIT=>NIC
        ljmp    M_NAS1                  ;Jinak cekej
        
;---------------------------------------
M_INFO:
        mov     R2,#192d                ;Info
        lcall   D_MENU                  ;Zobraz na display
M_INF1:
        lcall   TLACITKA                ;Zavolej tlacitka
        mov     R1,#2d                  ;R1 pocet opakovani 0.1s
        lcall   PAUZA                   ;Zavolej pauzu
        jnb     SIPKA,MI1               ;Test na sipku
        ljmp    M_VYPNOUT               ;SIPKA=>M_VYPNOUT
MI1:    jnb     ENTER,MI2               ;Test na enter
        ljmp    M_INFORMACE             ;ENTER=>M_INFORMACE
MI2:                                    ;ZRUSIT=>NIC
        ljmp    M_INF1                  ;Jinak cekej

;---------------------------------------
M_VYPNOUT:
        mov     R2,#208d                ;Vypnout?
        lcall   D_MENU                  ;Zobraz na display
M_VYP1:
        lcall   TLACITKA                ;Zavolej tlacitka
        mov     R1,#2d                  ;R1 pocet opakovani 0.1s
        lcall   PAUZA                   ;Zavolej pauzu
        jnb     SIPKA,MV1               ;Test na sipku
        ljmp    M_ZOBRAZ                ;SIPKA=>M_ZOBRAZ
MV1:    jnb     ENTER,MV2               ;Test na enter
        ljmp    M_VYP_ANONE             ;ENTER=>M_VYP_ANONE
MV2:                                    ;ZRUSIT=>NIC
        ljmp    M_VYP1                  ;Jinak cekej

;---------------------------------------
M_VYP_ANONE:
        mov     R2,#64d                 ;Ano,Ne
        lcall   D_MENU                  ;Zobraz na display
        clr     RES                     ;    -----------------------
        clr     R_W                     ;                           |
        mov     R0,#10000110b           ;Pozice 6h=DDRAM            |
        lcall   D_COMMAND               ;                           |Ano <=
        setb    RES                     ;                           |Ne
        clr     R_W                     ;                           |
        mov     R0,#00000100b           ;Adresa 4, sipka prvni cast |
        lcall   D_COMMAND               ;                           |
        mov     R0,#00000101b           ;Adresa 5, sipka druha cast |
        lcall   D_COMMAND               ;    -----------------------

M_ANON1:
        lcall   TLACITKA                ;Zavolej tlacitka
        mov     R1,#2d                  ;R1 pocet opakovani 0.1s
        lcall   PAUZA                   ;Zavolej pauzu
        jnb     SIPKA,MAN1              ;Test na sipku
        ljmp    M_VYP_NEANO             ;SIPKA=>M_VYP_NEANO
MAN1:   jnb     ENTER,MAN2              ;Test na enter
        ljmp    M_VYP_ANO               ;ENTER=>M_VYP_ANO
MAN2:   jnb     ZRUSIT,MAN3             ;Test na zrusit
        ljmp    M_VYPNOUT               ;ZRUSIT=>M_VYPNOUT
MAN3:
        ljmp    M_ANON1                 ;Jinak cekej

;---------------------------------------
M_VYP_NEANO:
        mov     R2,#64d                 ;Ano,Ne
        lcall   D_MENU                  ;Zobraz na display
        clr     RES                     ;    -----------------------
        clr     R_W                     ;                           |
        mov     R0,#11000110b           ;Pozice 46h=DDRAM           |
        lcall   D_COMMAND               ;                           |Ano 
        setb    RES                     ;                           |Ne  <=
        clr     R_W                     ;                           |
        mov     R0,#00000100b           ;Adresa 4, sipka prvni cast |
        lcall   D_COMMAND               ;                           |
        mov     R0,#00000101b           ;Adresa 5, sipka druha cast |
        lcall   D_COMMAND               ;    -----------------------

M_ANON2:
        lcall   TLACITKA                ;Zavolej tlacitka
        mov     R1,#2d                  ;R1 pocet opakovani 0.1s
        lcall   PAUZA                   ;Zavolej pauzu
        jnb     SIPKA,MAN4              ;Test na sipku
        ljmp    M_VYP_ANONE             ;SIPKA=>M_VYP_ANONE
MAN4:   jnb     ENTER,MAN5              ;Test na enter
        ljmp    M_VYPNOUT               ;ENTER=>M_VYPNOUT
MAN5:   jnb     ZRUSIT,MAN6             ;Test na zrusit
        ljmp    M_VYPNOUT               ;ZRUSIT=>M_VYPNOUT
MAN6:
        ljmp    M_ANON2                 ;Jinak cekej

;---------------------------------------
M_VYP_ANO:

	lcall   E_START                 ;Start
        mov     R0,#10100000b           ;Adresa+W
        lcall   E_ADR_DAT               ;Posli
        lcall   E_ACK                   ;Ack
        mov     R0,#00000100b           ;Adresa dat 4
        lcall   E_ADR_DAT               ;Posli
        lcall   E_ACK                   ;Ack
        mov     R0,P_KROK_H             ;Data=P_KROK_H 4
        lcall   E_ADR_DAT               ;Posli
        lcall   E_ACK                   ;Ack
        
        lcall   D_PAUZA

        mov     R0,P_KROK_M             ;Data=P_KROK_M 5
        lcall   E_ADR_DAT               ;Posli
        lcall   E_ACK                   ;Ack

	lcall	D_PAUZA

        mov     R0,P_KROK_L             ;Data=P_KROK_L 6
        lcall   E_ADR_DAT               ;Posli
        lcall   E_ACK                   ;Ack

	lcall	D_PAUZA

        mov     R0,D_TRASY_H            ;Data=D_TRASY_H 7
        lcall   E_ADR_DAT               ;Posli
        lcall   E_ACK                   ;Ack
        lcall   E_STOP                  ;Stop

        mov     R1,#1d                  ;R1 pocet opakovani 0.05s
        lcall   PAUZA                   ;Zavolej pauzu
        
	lcall   E_START                 ;Start
        mov     R0,#10100000b           ;Adresa+W
        lcall   E_ADR_DAT               ;Posli
        lcall   E_ACK                   ;Ack
        mov     R0,#00001000b           ;Adresa dat 8
        lcall   E_ADR_DAT               ;Posli
        lcall   E_ACK                   ;Ack
        mov     R0,D_TRASY_M            ;Data=D_TRASY_M 8
        lcall   E_ADR_DAT               ;Posli
        lcall   E_ACK                   ;Ack

	lcall	D_PAUZA

        mov     R0,D_TRASY_L            ;Data=D_TRASY_L 9
        lcall   E_ADR_DAT               ;Posli
        lcall   E_ACK                   ;Ack
        lcall   E_STOP                  ;Stop

        mov     R1,#1d                  ;R1 pocet opakovani 0.05s
        lcall   PAUZA                   ;Zavolej pauzu

        clr     RES
        clr     R_W
        mov     R0,#00001000b           ;Vypni LCD
        lcall   D_COMMAND               ;Proved
M_VYP_OP:
        setb    DRZ                     ;Vypni krokomer
        ljmp    M_VYP_OP                ;Dokud se nevypne

;---------------------------------------
M_INFORMACE:
        clr     RES                     ;    -----------------------
        clr     R_W                     ;                           |
        mov     R0,#10000000b           ;Pozice 0d=DDRAM            |
        lcall   D_COMMAND               ;                           |Napise
        setb    RES                     ;                           |info 1
        clr     R_W                     ;                           |
        mov     R0,#01001011b           ; K                         |
        lcall   D_COMMAND               ;                           |
        mov     R0,#01110010b           ; r                         |
        lcall   D_COMMAND               ;                           |
        mov     R0,#01101111b           ; o                         |
        lcall   D_COMMAND               ;                           |
        mov     R0,#01101011b           ; k                         |
        lcall   D_COMMAND               ;                           |
        mov     R0,#01101111b           ; o                         |
        lcall   D_COMMAND               ;                           |
        mov     R0,#01101101b           ; m                         |
        lcall   D_COMMAND               ;                           |
        mov     R0,#00000110b           ;                          |
        lcall   D_COMMAND               ;                           |
        mov     R0,#01110010b           ; r                         |
        lcall   D_COMMAND               ;                           |
        clr     RES                     ;    -----------------------
        clr     R_W                     ;                           |
        mov     R0,#11000000b           ;Pozice 40h=DDRAM           |
        lcall   D_COMMAND               ;                           |Napise
        setb    RES                     ;                           |info 2
        clr     R_W                     ;                           |
        mov     R0,#01110110b           ; v                         |
        lcall   D_COMMAND               ;                           |
        mov     R0,#00101110b           ; .                         |
        lcall   D_COMMAND               ;                           |
        mov     R0,#00100000b           ; mezera                    |
        lcall   D_COMMAND               ;                           |
        mov     R0,#00110001b           ; 1                         |
        lcall   D_COMMAND               ;                           |
        mov     R0,#00101110b           ; .                         |
        lcall   D_COMMAND               ;                           |
        mov     R0,#00110101b           ; 5                         |
        lcall   D_COMMAND               ;                           |
        mov     R0,#00110111b           ; 7                         |
        lcall   D_COMMAND               ;                           |
        mov     R0,#00100000b           ; mezera                    |
        lcall   D_COMMAND               ;    -----------------------

M_INF2:
        lcall   TLACITKA                ;Zavolej tlacitka
        mov     R1,#2d                  ;R1 pocet opakovani 0.1s
        lcall   PAUZA                   ;Zavolej pauzu
        jnb     ZRUSIT,MMIN1            ;Test na zrusit
        ljmp    M_INFO                  ;ZRUSIT=>M_INFO
MMIN1:                                  ;SIPKA=>NIC
                                        ;ENTER=>NIC
        ljmp    M_INF2                  ;Jinak cekej

;---------------------------------------
M_TRASA:
        mov     R2,#16d                 ;Trasa 1
        lcall   D_MENU                  ;Zobraz na display
M_TRA1:
        lcall   TLACITKA                ;Zavolej tlacitka
        jnb     SIPKA,MTRA1             ;Test na sipku
        mov     R1,#2d                  ;R1 pocet opakovani 0.1s
        lcall   PAUZA                   ;Zavolej pauzu                  
        ljmp    M_KROKY                 ;SIPKA=>M_KROKY
MTRA1:  jnb     ZRUSIT,MTRA2            ;Test na zrusit
        mov     R1,#2d                  ;R1 pocet opakovani 0.1s       
        lcall   PAUZA                   ;Zavolej pauzu                  
        ljmp    M_ZOBRAZ                ;ZRUSIT=>M_ZOBRAZ
MTRA2:                                  ;ENTER=>NIC
        clr     RES                     ;       --------------------
        clr     R_W                     ;                           |
        mov     R0,#11000000b           ;Pozice 40h=DDRAM           |zobraz
        lcall   D_COMMAND               ;                           |8 cisel
        mov     R4,D_TRASY_H            ;Data (H)                   |
        mov     R3,D_TRASY_M            ;Data (M)                   |
        mov     R2,D_TRASY_L            ;Data (L)                   |
        lcall   ZOB_8CISLA              ;Zobraz 8 cisel             |
        clr     RES                     ;    -----------------------
        clr     R_W                     ;                           |
        mov     R0,#11000110b           ;Pozice 46h=DDRAM           |
        lcall   D_COMMAND               ;                           |mezera
        setb    RES                     ;                           |+
        clr     R_W                     ;                           |m
        mov     R0,#00100000b           ;mezera                     |
        lcall   D_COMMAND               ;                           |
        mov     R0,#01101101b           ; m                         |
        lcall   D_COMMAND               ;    -----------------------

        clr     EX0                     ;Zakaz vnejsiho preruseni INT0
        mov     ZRY_LT1,DTXL_T1         ;
        mov     ZRY_HT1,DTXH_T1         ;Abych neovlivnil dalsi procedury
        mov     ZRY_LT2,DTXL_T2         ;blokace preruseni na co nejmensi
        mov     ZRY_HT2,DTXH_T2         ;dobu.
        setb    EX0                     ;Povoleni INT0

        lcall   ZRYCHLENI               ;Vypocti zrychleni

        mov     A,CO
        xrl     A,#00000101b            ;5
        jnz     Z_DALSI_DATAZ           ;A!=5 => preskoc
        mov     C,ZNAMENKO              ;C=ZNAMENKO
        mov     Z_ZNAMENKO,C            ;Abych neovlivnil vysilana data
        mov     Z_CELA_CAST,CELA_CAST   ;UARTu. Nutno po vypoctu ZRYCHLENI
        mov     Z_DESETC_H,DESETC_H     ;zachovat, nebot UPRAV_HLADINU meni
        mov     Z_DESETC_L,DESETC_L     ;prislusne registry.
        mov     CO,#0h                  ;Vynuluj na zacatek

Z_DALSI_DATAZ:
        lcall   UPRAV_HLADINU           ;Uprav podle orezove hladiny (sum)
        lcall   KLOUZAVY_PRUMER         ;Vypocitej klouzavy prumer
        lcall   TEST_KROK               ;Jestli je dalsi krok
              
        lcall   DATA_OUT                ;Seriova linka, inicializace

        ljmp    M_TRA1                  ;Jinak cekej

;---------------------------------------
M_KROKY:
        mov     R2,#32d                 ;Kroky 2
        lcall   D_MENU                  ;Zobraz na display
M_KRO1:
        lcall   TLACITKA                ;Zavolej tlacitka
        jnb     SIPKA,MKRO1             ;Test na sipku
        mov     R1,#2d                  ;R1 pocet opakovani 0.1s
        lcall   PAUZA                   ;Zavolej pauzu                  
        ljmp    M_SMAZAT                ;SIPKA=>M_SMAZAT
MKRO1:  jnb     ZRUSIT,MKRO2            ;Test na zrusit
        mov     R1,#2d                  ;R1 pocet opakovani 0.1s
        lcall   PAUZA                   ;Zavolej pauzu                  
        ljmp    M_ZOBRAZ                ;ZRUSIT=>M_ZOBRAZ
MKRO2:                                  ;ENTER=>NIC
        clr     RES                     ;       --------------------
        clr     R_W                     ;                           |
        mov     R0,#10100110b           ;Pozice 26h=DDRAM           |zobraz
        lcall   D_COMMAND               ;                           |8 cisel
        mov     R4,P_KROK_H             ;Data (H)                   |
        mov     R3,P_KROK_M             ;Data (M)                   |
        mov     R2,P_KROK_L             ;Data (L)                   |
        lcall   ZOB_8CISLA              ;Zobraz 8 cisel  -----------
        
        clr     EX0                     ;Zakaz vnejsiho preruseni INT0
        mov     ZRY_LT1,DTXL_T1         ;
        mov     ZRY_HT1,DTXH_T1         ;Abych neovlivnil dalsi procedury
        mov     ZRY_LT2,DTXL_T2         ;blokace preruseni na co nejmensi
        mov     ZRY_HT2,DTXH_T2         ;dobu.
        setb    EX0                     ;Povoleni INT0

        lcall   ZRYCHLENI               ;Vypocti zrychleni

        mov     A,CO
        xrl     A,#00000101b            ;5
        jnz     Z_DALSI_DATAK           ;A!=5 => preskoc
        mov     C,ZNAMENKO              ;C=ZNAMENKO
        mov     Z_ZNAMENKO,C            ;Abych neovlivnil vysilana data
        mov     Z_CELA_CAST,CELA_CAST   ;UARTu. Nutno po vypoctu ZRYCHLENI
        mov     Z_DESETC_H,DESETC_H     ;zachovat, nebot UPRAV_HLADINU meni
        mov     Z_DESETC_L,DESETC_L     ;prislusne registry.
        mov     CO,#0h                  ;Vynuluj na zacatek

Z_DALSI_DATAK:
        lcall   UPRAV_HLADINU           ;Uprav podle orezove hladiny (sum)
        lcall   KLOUZAVY_PRUMER         ;Vypocitej klouzavy prumer
        lcall   TEST_KROK               ;Jestli je dalsi krok
              
        lcall   DATA_OUT                ;Seriova linka, inicializace

        ljmp    M_KRO1                  ;Jinak cekej

;---------------------------------------
M_SMAZAT:
        mov     R2,#48d                 ;Smazat 3 hodnoty?
        lcall   D_MENU                  ;Zobraz na display
M_SMA1:
        lcall   TLACITKA                ;Zavolej tlacitka
        mov     R1,#2d                  ;R1 pocet opakovani 0.1s
        lcall   PAUZA                   ;Zavolej pauzu
        jnb     SIPKA,MSM1              ;Test na sipku
        ljmp    M_TRASA                 ;SIPKA=>M_TRASA
MSM1:   jnb     ENTER,MSM2              ;Test na enter
        ljmp    M_SMA_ANONE             ;ENTER=>M_SMA_ANONE
MSM2:   jnb     ZRUSIT,MSM3             ;Test na zrusit
        ljmp    M_ZOBRAZ                ;ZRUSIT=>M_ZOBRAZ
MSM3:
        ljmp    M_SMA1                  ;Jinak cekej

;---------------------------------------
M_SMA_ANONE:
        mov     R2,#64d                 ;Ano,Ne
        lcall   D_MENU                  ;Zobraz na display
        clr     RES                     ;    -----------------------
        clr     R_W                     ;                           |
        mov     R0,#10000110b           ;Pozice 6h=DDRAM            |
        lcall   D_COMMAND               ;                           |Ano <=
        setb    RES                     ;                           |Ne
        clr     R_W                     ;                           |
        mov     R0,#00000100b           ;Adresa 4, sipka prvni cast |
        lcall   D_COMMAND               ;                           |
        mov     R0,#00000101b           ;Adresa 5, sipka druha cast |
        lcall   D_COMMAND               ;    -----------------------

M_SANON1:
        lcall   TLACITKA                ;Zavolej tlacitka
        mov     R1,#2d                  ;R1 pocet opakovani 0.1s
        lcall   PAUZA                   ;Zavolej pauzu
        jnb     SIPKA,MSAN1             ;Test na sipku
        ljmp    M_SMA_NEANO             ;SIPKA=>M_SMA_NEANO
MSAN1:  jnb     ENTER,MSAN2             ;Test na enter
        ljmp    M_SMA_ANO               ;ENTER=>M_SMA_ANO
MSAN2:  jnb     ZRUSIT,MSAN3            ;Test na zrusit
        ljmp    M_SMAZAT                ;ZRUSIT=>M_SMAZAT
MSAN3:
        ljmp    M_SANON1                ;Jinak cekej

;---------------------------------------
M_SMA_NEANO:
        mov     R2,#64d                 ;Ano,Ne
        lcall   D_MENU                  ;Zobraz na display
        clr     RES                     ;    -----------------------
        clr     R_W                     ;                           |
        mov     R0,#11000110b           ;Pozice 46h=DDRAM           |
        lcall   D_COMMAND               ;                           |Ano 
        setb    RES                     ;                           |Ne  <=
        clr     R_W                     ;                           |
        mov     R0,#00000100b           ;Adresa 4, sipka prvni cast |
        lcall   D_COMMAND               ;                           |
        mov     R0,#00000101b           ;Adresa 5, sipka druha cast |
        lcall   D_COMMAND               ;    -----------------------

M_SANON2:
        lcall   TLACITKA                ;Zavolej tlacitka
        mov     R1,#2d                  ;R1 pocet opakovani 0.1s
        lcall   PAUZA                   ;Zavolej pauzu
        jnb     SIPKA,SMAN4             ;Test na sipku
        ljmp    M_SMA_ANONE             ;SIPKA=>M_SMA_ANONE
SMAN4:  jnb     ENTER,SMAN5             ;Test na enter
        ljmp    M_SMAZAT                ;ENTER=>M_SMAZAT
SMAN5:  jnb     ZRUSIT,SMAN6            ;Test na zrusit
        ljmp    M_SMAZAT                ;ZRUSIT=>M_SMAZAT
SMAN6:
        ljmp    M_SANON2                ;Jinak cekej

;---------------------------------------
M_SMA_ANO:
        mov     D_TRASY_L,#0d           ;Smaz TRASU
        mov     D_TRASY_M,#0d           ;
        mov     D_TRASY_H,#0d           ;
        mov     P_KROK_L,#0d            ;Smaz KROKY
        mov     P_KROK_M,#0d            ;
        mov     P_KROK_H,#0d            ;

        mov     R2,#224d                ;Smazano!
        lcall   D_MENU                  ;Zobraz na display
        lcall   BEEP                    ;Pipni
        mov     R1,#6d                  ;R1 pocet opakovani 0.3s
        lcall   PAUZA                   ;Zavolej pauzu

        ljmp    M_SMAZAT                ;Pak skoc

;---------------------------------------
M_DELKA_KROKU:
        mov     R2,#96d                 ;Delka 1 kroku
        lcall   D_MENU                  ;Zobraz na display
M_DEL1:
        lcall   TLACITKA                ;Zavolej tlacitka
        mov     R1,#2d                  ;R1 pocet opakovani 0.1s
        lcall   PAUZA                   ;Zavolej pauzu
        jnb     SIPKA,MD1               ;Test na sipku
        ljmp    M_DATA_VYS              ;SIPKA=>M_DATA_VYS
MD1:    jnb     ENTER,MD2               ;Test na enter
        ljmp    M_KROK1                 ;ENTER=>M_KROK1
MD2:    jnb     ZRUSIT,MD3              ;Test na zrusit
        ljmp    M_NASTAV                ;ZRUSIT=>M_NASTAV
MD3:
        ljmp    M_DEL1                  ;Jinak cekej

;---------------------------------------
M_DATA_VYS:
        mov     R2,#128d                ;Data k 2 vysilani
        lcall   D_MENU                  ;Zobraz na display
M_DAT1:
        lcall   TLACITKA                ;Zavolej tlacitka
        mov     R1,#2d                  ;R1 pocet opakovani 0.1s
        lcall   PAUZA                   ;Zavolej pauzu
        jnb     SIPKA,MDV1              ;Test na sipku
        ljmp    M_KALIBR                ;SIPKA=>M_KALIBR
MDV1:   jnb     ENTER,MDV2              ;Test na enter
        ljmp    M_ZRY_KRO               ;ENTER=>M_ZRY_KRO
MDV2:   jnb     ZRUSIT,MDV3             ;Test na zrusit
        ljmp    M_NASTAV                ;ZRUSIT=>M_NASTAV
MDV3:
        ljmp    M_DAT1                  ;Jinak cekej

;---------------------------------------
M_KALIBR:
        mov     R2,#160d                ;Kalibr 3
        lcall   D_MENU                  ;Zobraz na display
M_KAL1:
        lcall   TLACITKA                ;Zavolej tlacitka
        mov     R1,#2d                  ;R1 pocet opakovani 0.1s
        lcall   PAUZA                   ;Zavolej pauzu
        jnb     SIPKA,MK1               ;Test na sipku
        ljmp    M_DELKA_KROKU           ;SIPKA=>M_DELKA_KROKU
MK1:    jnb     ENTER,MK2               ;Test na enter
        ljmp    M_POLOZ_A               ;ENTER=>M_POLOZ_A
MK2:    jnb     ZRUSIT,MK3              ;Test na zrusit
        ljmp    M_NASTAV                ;ZRUSIT=>M_NASTAV
MK3:
        ljmp    M_KAL1                  ;Jinak cekej

;---------------------------------------
M_KROK1:
        mov     R2,#112d                ;D.kroku: cm
        lcall   D_MENU                  ;Zobraz na display
M_KRO11:
        clr     RES                     ;       --------------------
        clr     R_W                     ;                           |
        mov     R0,#11000010b           ;Pozice 42h=DDRAM           |zobraz
        lcall   D_COMMAND               ;                           |3 cisla
                                        ;                           |
        clr     C                       ;Smaz CARRY                 |
        mov     A,D_KROKU               ;A=D_KROKU                  |
        subb    A,#131d                 ;Jestli nejsem vys nez 131d |
        jc      NIC_D_KR                ;C=1=>Nic                   |
        mov     D_KROKU,#60d            ;C=0, je vetsi              |
                                        ;                           |
NIC_D_KR:                               ;                           |
        mov     DATA_Z,D_KROKU          ;Data (D_KROKU)             |
        lcall   ZOB_3CISLA              ;Zobraz 3 cisla  -----------

        lcall   TLACITKA                ;Zavolej tlacitka
        mov     R1,#1d                  ;R1 pocet opakovani 0.05s
        lcall   PAUZA                   ;Zavolej pauzu
        jnb     SIPKA,MKR1              ;Test na sipku
                                        ;SIPKA=>zvys o 1
        inc     D_KROKU                 ;Zvys delku kroku
        clr     C                       ;Smaz CARRY
        mov     A,D_KROKU               ;A=D_KROKU
        subb    A,#131d                 ;Jestli se rovnam
        jnz     NENI_130                ;Jestli A!=0 pak skoc
        mov     D_KROKU,#30d            ;A=0, dolni hranice
NENI_130:

MKR1:   jnb     ENTER,MKR2              ;Test na enter
        ljmp    M_D_NASTAVENO           ;ENTER=>M_D_NASTAVENO
MKR2:   jnb     ZRUSIT,MKR3             ;Test na zrusit
        ljmp    M_DELKA_KROKU           ;ZRUSIT=>M_DELKA_KROKU
MKR3:
        ljmp    M_KRO11                 ;Jinak cekej

;---------------------------------------
M_D_NASTAVENO:

        lcall   E_START                 ;Start
        mov     R0,#10100000b           ;Adresa+W
        lcall   E_ADR_DAT               ;Posli
        lcall   E_ACK                   ;Ack
        mov     R0,#00000010b           ;Adresa dat 2
        lcall   E_ADR_DAT               ;Posli
        lcall   E_ACK                   ;Ack
        mov     R0,D_KROKU              ;Data=D_KROKU 2
        lcall   E_ADR_DAT               ;Posli
        lcall   E_ACK                   ;Ack
        lcall   E_STOP                  ;Stop

        mov     R2,#240d                ;Nastav. Ulozeno!
        lcall   D_MENU                  ;Zobraz na display
        lcall   BEEP                    ;Pipni
        mov     R1,#6d                  ;R1 pocet opakovani 0.3s
        lcall   PAUZA                   ;Zavolej pauzu

        ljmp    M_DELKA_KROKU           ;Pak skoc

;---------------------------------------
M_ZRY_KRO:
        mov     A,NASTA_SV              ;A=NASTA_SV
        jnz     M_KRO_ZRY               ;A!=0 => M_KRO_ZRY
                                        ;A=0
M_ZRY_KRO_N:
        mov     R2,#144d                ;Zrych. krok
        lcall   D_MENU                  ;Zobraz na display
        clr     RES                     ;    -----------------------
        clr     R_W                     ;                           |
        mov     R0,#10000110b           ;Pozice 6h=DDRAM            |
        lcall   D_COMMAND               ;                           |Zry <=
        setb    RES                     ;                           |Krok
        clr     R_W                     ;                           |
        mov     R0,#00000100b           ;Adresa 4, sipka prvni cast |
        lcall   D_COMMAND               ;                           |
        mov     R0,#00000101b           ;Adresa 5, sipka druha cast |
        lcall   D_COMMAND               ;    -----------------------

M_ZRY1:
        lcall   TLACITKA                ;Zavolej tlacitka
        mov     R1,#2d                  ;R1 pocet opakovani 0.1s
        lcall   PAUZA                   ;Zavolej pauzu
        jnb     SIPKA,MZR1              ;Test na sipku
        ljmp    M_KRO_ZRY               ;SIPKA=>M_KRO_ZRY
MZR1:   jnb     ENTER,MZR2              ;Test na enter
        mov     NASTA_SV,#0d            ;Nastaveni komunikace
        ljmp    M_V_NASTAVENO           ;ENTER=>M_V_NASTAVENO
MZR2:   jnb     ZRUSIT,MZR3             ;Test na zrusit
        ljmp    M_DATA_VYS              ;ZRUSIT=>M_DATA_VYS
MZR3:
        ljmp    M_ZRY1                  ;Jinak cekej

;---------------------------------------
M_KRO_ZRY:
        mov     R2,#144d                ;Zrych. krok
        lcall   D_MENU                  ;Zobraz na display
        clr     RES                     ;    -----------------------
        clr     R_W                     ;                           |
        mov     R0,#11000110b           ;Pozice 46h=DDRAM           |
        lcall   D_COMMAND               ;                           |Zry 
        setb    RES                     ;                           |Krok <=
        clr     R_W                     ;                           |
        mov     R0,#00000100b           ;Adresa 4, sipka prvni cast |
        lcall   D_COMMAND               ;                           |
        mov     R0,#00000101b           ;Adresa 5, sipka druha cast |
        lcall   D_COMMAND               ;    -----------------------

M_KZY1:
        lcall   TLACITKA                ;Zavolej tlacitka
        mov     R1,#2d                  ;R1 pocet opakovani 0.1s
        lcall   PAUZA                   ;Zavolej pauzu
        jnb     SIPKA,SRY1              ;Test na sipku
        ljmp    M_ZRY_KRO_N             ;SIPKA=>M_ZRY_KRO_N
SRY1:   jnb     ENTER,SRY2              ;Test na enter
        mov     NASTA_SV,#0FFh          ;Nastaveni komunikace
        ljmp    M_V_NASTAVENO           ;ENTER=>M_V_NASTAVENO
SRY2:   jnb     ZRUSIT,SRY3             ;Test na zrusit
        ljmp    M_DATA_VYS              ;ZRUSIT=>M_DATA_VYS
SRY3:
        ljmp    M_KZY1                  ;Jinak cekej

;---------------------------------------
M_V_NASTAVENO:

        lcall   E_START                 ;Start
        mov     R0,#10100000b           ;Adresa+W
        lcall   E_ADR_DAT               ;Posli
        lcall   E_ACK                   ;Ack
        mov     R0,#00000011b           ;Adresa dat 3
        lcall   E_ADR_DAT               ;Posli
        lcall   E_ACK                   ;Ack
        mov     R0,NASTA_SV             ;Data=NASTA_SV 3
        lcall   E_ADR_DAT               ;Posli
        lcall   E_ACK                   ;Ack
        lcall   E_STOP                  ;Stop

        mov     R2,#240d                ;Nastav. Ulozeno!
        lcall   D_MENU                  ;Zobraz na display
        lcall   BEEP                    ;Pipni
        mov     R1,#6d                  ;R1 pocet opakovani 0.3s
        lcall   PAUZA                   ;Zavolej pauzu

        ljmp    M_DATA_VYS              ;Pak skoc

;---------------------------------------
M_POLOZ_A:

        mov     R2,#176d                ;Poloz na stranu
        lcall   D_MENU                  ;Zobraz na display
        clr     RES                     ;    -----------------------
        clr     R_W                     ;                           |
        mov     R0,#11000111b           ;Pozice 47h=DDRAM           |
        lcall   D_COMMAND               ;                           |
        setb    RES                     ;                           | A
        clr     R_W                     ;                           |
        mov     R0,#01000001b           ;Pismeno A                  |
        lcall   D_COMMAND               ;    -----------------------

        mov     R0,#50d                 ;Pocet opakovani        ----
POL1_NE:                                ;                           |
        mov     R1,#1d                  ;R1 pocet opakovani 0.05s   |
        lcall   PAUZA                   ;Zavolej pauzu              |
        lcall   TLACITKA                ;Zavolej tlacitka           |
        jnb     ZRUSIT,POL1             ;Test na zrusit             |Cekej
        mov     R1,#2d                  ;R1 pocet opakovani 0.1s   |a
        lcall   PAUZA                   ;Zavolej pauzu              |testuj
        ljmp    M_KALIBR                ;SIPKA=>M_KALIBR            |tlacit.
POL1:                                   ;                           |
        djnz    R0,POL1_NE              ;R0-1 a testuj na skok      |
                                        ;       --------------------

        clr     EX0                     ;Zakaz vnejsiho preruseni INT0
        mov     ZRY_LT1,DTXL_T1         ;
        mov     ZRY_HT1,DTXH_T1         ;Abych neovlivnil dalsi procedury
        mov     ZRY_LT2,DTXL_T2         ;blokace preruseni na co nejmensi
        mov     ZRY_HT2,DTXH_T2         ;dobu.
        setb    EX0                     ;Povoleni INT0
                                        ;A=+1G
        lcall   DELENI_T1_T2            ;Zavolej deleni     --------
        mov     VYSL_4,VYSL_2           ;+1G (H)                    |Zapis
        mov     VYSL_3,VYSL_1           ;+1G (L)                    |+1G
        lcall   BEEP                    ;Pipni         -------------

        clr     RES                     ;    -----------------------
        clr     R_W                     ;                           |
        mov     R0,#11000111b           ;Pozice 47h=DDRAM           |
        lcall   D_COMMAND               ;                           |
        setb    RES                     ;                           | B
        clr     R_W                     ;                           |
        mov     R0,#01000010b           ;Pismeno B                  |
        lcall   D_COMMAND               ;    -----------------------

        mov     R0,#50d                 ;Pocet opakovani  ----------
POL2_NE:                                ;                           |
        mov     R1,#1d                  ;R1 pocet opakovani 0.05s   |
        lcall   PAUZA                   ;Zavolej pauzu              |
        lcall   TLACITKA                ;Zavolej tlacitka           |
        jnb     ZRUSIT,POL2             ;Test na zrusit             |Cekej
        mov     R1,#2d                  ;R1 pocet opakovani 0.1s   |a
        lcall   PAUZA                   ;Zavolej pauzu              |testuj
        ljmp    M_KALIBR                ;SIPKA=>M_KALIBR            |tlacit.
POL2:                                   ;                           |
        djnz    R0,POL2_NE              ;R0-1 a testuj na skok      |
                                        ;       --------------------

        clr     EX0                     ;Zakaz vnejsiho preruseni INT0
        mov     ZRY_LT1,DTXL_T1         ;
        mov     ZRY_HT1,DTXH_T1         ;Abych neovlivnil dalsi procedury
        mov     ZRY_LT2,DTXL_T2         ;blokace preruseni na co nejmensi
        mov     ZRY_HT2,DTXH_T2         ;dobu.
        setb    EX0                     ;Povoleni INT0
                                        ;A=-1G
        lcall   DELENI_T1_T2            ;Zavolej deleni     -------- Zapis
                                        ;-1G VYSL_2(H), VYSL_1(L)   |-1G
        lcall   BEEP                    ;Pipni          ------------ 

        clr     RES                     ;    -----------------------
        clr     R_W                     ;                           |
        mov     R0,#11000111b           ;Pozice 47h=DDRAM           |
        lcall   D_COMMAND               ;                           |
        setb    RES                     ;                           | C
        clr     R_W                     ;                           |
        mov     R0,#01000011b           ;Pismeno C                  |
        lcall   D_COMMAND               ;    -----------------------

        mov     R0,#50d                 ;Pocet opakovani   ---------
POL3_NE:                                ;                           |
        mov     R1,#1d                  ;R1 pocet opakovani 0.05s   |
        lcall   PAUZA                   ;Zavolej pauzu              |
        lcall   TLACITKA                ;Zavolej tlacitka           |Cekej
        jnb     ZRUSIT,POL3             ;Test na zrusit             |a
        mov     R1,#2d                  ;R1 pocet opakovani 0.1s    |testuj
        lcall   PAUZA                   ;Zavolej pauzu              |tlacit.
        ljmp    M_KALIBR                ;SIPKA=>M_KALIBR            |
POL3:                                   ;                           |
        djnz    R0,POL3_NE              ;R0-1 a testuj na skok      |
                                        ;       --------------------

        clr     EX0                     ;Zakaz vnejsiho preruseni INT0
        mov     ZRY_LT1,DTXL_T1         ;
        mov     ZRY_HT1,DTXH_T1         ;Abych neovlivnil dalsi procedury
        mov     ZRY_LT2,DTXL_T2         ;blokace preruseni na co nejmensi
        mov     ZRY_HT2,DTXH_T2         ;dobu.
        setb    EX0                     ;Povoleni INT0
                                        ;A=0G                ------- Nastav
        lcall   NASTAV_O_POSUN          ;Zpocitej O_POSUN           |novy
                                        ;Novy O_POSUN     ---------- O_POSUN

        clr     C                       ;CARRY=0, pocitam X_POSUN --
        mov     A,VYSL_3                ;A=+1G(L)                   |
        subb    A,VYSL_1                ;A=+1G(L) - -1G(L)          |
        mov     VYSL_1,A                ;VYSL_1=L                   |
        mov     A,VYSL_4                ;A=+1G(H)                   |
        subb    A,VYSL_2                ;A=+1G(H) - -1G(H)-CARRY    |Nastav
        mov     VYSL_2,A                ;VYSL_2=H                   |novy
                                        ;Budu delit dvema, RRC      |X_POSUN
        clr     C                       ;Smaz CARRY                 |
        mov     A,VYSL_2                ;Nejdrive vyssi byte        |
        rrc     A                       ;Rotace doprava             |
        mov     A,VYSL_1                ;Nizsi byte                 |
        rrc     A                       ;Rotace se zbytkem doprava  |
        mov     X_POSUN,A               ;X_POSUN=A=celkovy posun ---
        lcall   BEEP                    ;Pipni

                                        ;Uloz           ------------
        lcall   E_START                 ;Start                      |
        mov     R0,#10100000b           ;Adresa+W                   |
        lcall   E_ADR_DAT               ;Posli                      |
        lcall   E_ACK                   ;Ack                        |
        mov     R0,#00000000b           ;Adresa dat 0               |Uloz
        lcall   E_ADR_DAT               ;Posli                      |take
        lcall   E_ACK                   ;Ack                        |do
        mov     R0,X_POSUN              ;Data=X_POSUN 0             |EEPROM
        lcall   E_ADR_DAT               ;Posli                      |
        lcall   E_ACK                   ;Ack                        |
                                        ;                           |
        lcall   D_PAUZA                 ;                           |
                                        ;                           |
        mov     R0,O_POSUN              ;Data=O_POSUN 1             |
        lcall   E_ADR_DAT               ;Posli                      |
        lcall   E_ACK                   ;Ack                        |
        lcall   E_STOP                  ;Stop           ------------

        mov     R2,#240d                ;Nastav. ulozeno!
        lcall   D_MENU                  ;Zobraz na display
        lcall   BEEP                    ;Pipni
        mov     R1,#6d                  ;R1 pocet opakovani 0.3s
        lcall   PAUZA                   ;Zavolej pauzu

        ljmp    M_KALIBR                ;Pak skoc

;----------------------------------------
;---------------------------------------------------------------------------
;---------------------------------------------------------------------------
;---------------------------------------------------------------------------
        ;Obsluha preruseni od INT0
        ;CHODI
        ;-------
PRERUS_INT0:
	mov	DTXL_T1,TL0		;Zkopiruje T1 nizsi b.
	mov	DTXH_T1,TH0		;Zkopiruje T1 vyssi b.
        mov	TMOD,#00000001b		;Citej kdykoliv
MERIM_T2:
        jnb	DATA_Y,MERIM_T2		;Dokud je INT0=0 tak pocitej
	clr	TR0			;Zastav na chvili TIMER0	
        mov     DTXL_T2,TL0             ;Zkopiruje T2
        mov     DTXH_T2,TH0             ;Zkopiruje T2
	mov	TMOD,#00001001b		;Zase citej pri 1 na INT0
        mov     TL0,#12d                ;Kompenzace usleho casu
	mov	TH0,#0d			;Vynuluj citac T0-H
	setb	TR0			;Spust TIMER0
        RET

;---------------------------------------------------------------------------
        ;Obsluha preruseni od USARTu        
	;CHODI
	;-------
USART:
        push    ACC
	clr	TI			;Smaz priznak
	jb	SPINAC_T,KON_USART	;SPINAC_T=1 => KON_USART
        mov     A,NASTA_SV              ;Presunu NASTA_SV(co vysilat) do A
        jz      V_ZRYCH                 ;NASTA_SV=0 =>ZRYCHLENI => V_ZRYCH
                                        ;Kroky
	jnb	STAV_KROK,NENI_D_KROK	;Je zasunut, 0=neni dalsi krok=>skoc
        mov     SBUF,D_KROKU            ;Dalsi krok=1,SBUF=Delka kroku
	clr	STAV_KROK		;Ze musim pockat na dalsi data KROK
        pop     ACC
        RET

NENI_D_KROK:
        mov     SBUF,#0d                ;Neni KROK => posli MEZERU =>0d
        pop     ACC
	RET

V_ZRYCH:                                ;Vysilej zrychleni
	mov	A,CO
        xrl     A,#00000000b            ;0
	jz	TRD_0
	mov	A,CO
	xrl	A,#00000001b		;1
	jz	TRD_1
	mov	A,CO
	xrl	A,#00000010b		;2
	jz	TRD_2
	mov	A,CO
	xrl	A,#00000011b		;3
	jz	TRD_3
                                        ;4-5
	mov	SBUF,#0h		;Konec Zrychleni
        mov     CO,#5d                  ;Ze jsem uz vysilal i 0
        pop     ACC
        RET

TRD_0:	mov	A,#00110000b		;Znamenko=0
        jnb     Z_ZNAMENKO,TRD_ZNA0
	mov	A,#00111111b		;Znamenko=1
TRD_ZNA0:
	mov	SBUF,A
	inc	CO
        pop     ACC
        RET
TRD_1:	
        mov     SBUF,Z_CELA_CAST
	inc	CO
        pop     ACC
        RET
TRD_2:
        mov     SBUF,Z_DESETC_H
	inc	CO
        pop     ACC
        RET
TRD_3:
        mov     SBUF,Z_DESETC_L
        inc     CO
        pop     ACC
        RET

KON_USART:
	clr	TI			;Smaz priznak preruseni
	clr	TR2			;Zastav citac TIMER2
	clr	ES			;Zakaz preruseni USART
	clr	BEZI_USART		;Ze nebezi USART
        clr     STAV_KROK               ;Cekam na dalsi krok
        mov     CO,#4d                  ;Abych pouzil nova data
        pop     ACC
        RET

;---------------------------------------------------------------------------
        ;Cekani urcitou dobu (min. 0.05s), blokujici rezim
        ;Musi predchazet naplneni R1=pocet opakovani (TIME=R1*0.05)
        ;CHODI
        ;-------
PAUZA:
        mov     CAS_1H,#0C3h            ;Cas 50000=C350h
        mov     CAS_1L,#050h            ;
N_N_L1: djnz    CAS_1L,N_N_L1           ;CAS_1L-1=CAS_1L, nenulovy skoc
        mov     CAS_1L,#0FFh            ;Nizsi hodnota na FFh
        dec     CAS_1H                  ;Odecti 1 od vyssich bitu
        mov     A,CAS_1H		;A=CAS_1H
        cjne    A,#0FFh,N_N_L1          ;Testuj na podteceni, jinak skoc
        djnz    R1,PAUZA                ;Pocet 0.05 v R1
        RET

;---------------------------------------------------------------------------
        ;Spusti kmitocet 2000Hz na port P1.0 (PIP) blokujici rezim
        ;CHODI
        ;-------
BEEP:
	mov	R2,#64d			;Maximalni pauza, 2000Hz=>64ms
	clr	PIP			;Ze je to vystup
J_BEEP: lcall   D_PAUZA                 ;1=50us
        lcall   D_PAUZA                 ;2=100us
        lcall   D_PAUZA                 ;3=150us
        lcall   D_PAUZA                 ;4=200us
        lcall   D_PAUZA                 ;5=250us
	cpl	PIP			;Posli 0 nebo 1
	djnz	R2,J_BEEP		;Neni jeste konec kmitoctu?
        setb    PIP			;Nastav port na vstupni
        RET

;---------------------------------------------------------------------------
        ;Inicializace DISPLEJE (8bit data)
	;CHODI
	;-------
D_INIT:
        clr     RES                     ;RES=0
        clr     R_W                     ;R_W=0
        clr     DB7                     ;0-0010b, 4bit. operace
        clr     DB6                     ;0
        setb    DB5                     ;1
        clr     DB4                     ;0
        setb    ENA                     ;ENA=1 CLOCK
        nop                             ;Nic nedelej
        clr     ENA                     ;ENA=0
	mov	R1,#1d			;Pauza 50ms
        lcall   PAUZA                   ;Zavolej pauzu
					;Jeste jednou				
        clr     RES                     ;RES=0
        clr     R_W                     ;R_W=0
        clr     DB7                     ;0-0010b, 4bit. operace
        clr     DB6                     ;0
        setb    DB5                     ;1
        clr     DB4                     ;0
        setb    ENA                     ;ENA=1 CLOCK
        nop                             ;Nic nedelej
        clr     ENA                     ;ENA=0
        lcall   D_PAUZA                 ;Pauza 50us
        RET

;---------------------------------------------------------------------------
        ;Pauza pevnych 50us
        ;CHODI
        ;-------
D_PAUZA:
        mov     TEMP1,#50d              ;Pocet opakovani 50x
OPAK_50:
        djnz    TEMP1,OPAK_50           ;Odecti TEMP1-1, nerovna 0 =>OPAK_50
        RET

;---------------------------------------------------------------------------
        ;Ridici slovo rozlozene do 2x4bit posle na DISPLEJ
        ;Data v R0, nutno pred volanim nastavit RES,R_W
        ;Ctena data v R0
        ;CHODI
        ;-------
D_COMMAND:
        jb      RES,RES_1               ;RES=1 => RES_1
        jb      R_W,R_W_1_RES_01        ;RES=0,R_W=> R_W_1_RES_01
WRITE_D:                                ;RES=0,R_W=0
        mov     A,R0                    ;A=R0(data)             ---
	anl	A,#11110000b		;A=A and 11110000	   |
	mov	TEMP2,A			;Zaloha A		   |
	mov	A,P1			;A=Port1		   |Vyssi
	anl	A,#00001111b		;A=A and 00001111	   |4bity
	orl	A,TEMP2			;A=A or TEMP2 (sjednoceni) |
	mov	P1,A			;Zapis na branu P1	   |
        setb    ENA                     ;ENA=1  CLOCK              |
        nop                             ;Nic nedelej               |
        clr     ENA                     ;ENA=0                  ---

        mov     A,R0                    ;A=R0(data)             ---
	swap	A			;Obrat na nizsi 4bity	   |
	anl	A,#11110000b		;A=A and 11110000	   |
	mov	TEMP2,A			;Zaloha A		   |
        mov     A,P1                    ;A=Port1                   |Nizsi
	anl	A,#00001111b		;A=A and 00001111	   |4bity
	orl	A,TEMP2			;A=A or TEMP2 (sjednoceni) |
	mov	P1,A			;Zapis na branu P1	   |
        setb    ENA                     ;ENA=1  CLOCK              |
        nop                             ;Nic nedelej               |
        clr     ENA                     ;ENA=0                  ---
        lcall   D_PAUZA                 ;Zavolej pauzu 50us
        RET

RES_1:  jb      R_W,R_W_1_RES_01        ;RES=1
        ljmp    WRITE_D                 ;RES=1,R_W=0, WRITE jako RES,R_W=0

R_W_1_RES_01:                           ;RES=1,R_W=1    READ
                                        ;RES=0,R_W=1
        mov     P1,#0FFh                ;Aby to byl vstup
        setb    ENA                     ;ENA=1  CLOCK
        nop                             ;Nic nedelej
        clr     ENA                     ;ENA=0
        mov     A,P1                    ;A=obsah portu P1       --
        anl     A,#11110000b            ;A=DDDD0000               |Vyssi
        mov     R0,A                    ;R0=A=DDDD0000            |4bity
        setb    ENA                     ;ENA=1  CLOCK             |
        nop                             ;Nic nedelej              |
        clr     ENA                     ;ENA=0                  --
        mov     A,P1                    ;A=obsah portu P1       --
        anl     A,#11110000b            ;A=DDDD0000               |Nizsi
        swap    A                       ;A=0000DDDD               |4bity
        orl     A,R0                    ;A=0000DDDD or DDDD0000   |
        mov     R0,A                    ;R0=precteny byte       --
        lcall   D_PAUZA                 ;Zavolej pauzu 50us
        RET

;---------------------------------------------------------------------------
	;Zacatek prenosu EEPROM
        ;CHODI
        ;-------
E_START:
	setb	EE_CLK			;CLK=1
        lcall   D_PAUZA
	setb	EE_DAT			;DAT=1
        lcall   D_PAUZA
	clr	EE_DAT			;DAT=0
        lcall   D_PAUZA
	clr	EE_CLK			;CLK=0
        lcall   D_PAUZA
	RET

;---------------------------------------------------------------------------
	;Adresa nebo data EEPROM
        ;CHODI
        ;-------
E_ADR_DAT:
	mov	TEMP2,#8d		;TEMP2=pocet opakovani 8x
	mov	A,R0			;A=R0
ADCO:	rlc	A			;Rotace doleva pres C
	mov	EE_DAT,C		;C=>DAT
        lcall   D_PAUZA
	setb	EE_CLK			;CLK=1
        lcall   D_PAUZA
	clr	EE_CLK			;CLK=0
        lcall   D_PAUZA
	djnz	TEMP2,ADCO		;Neni jeste 8bitu poslano
	clr	EE_DAT			;DAT=0
        mov     R1,#1d                  ;0.05s
        lcall   PAUZA 
	RET

;---------------------------------------------------------------------------
	;Potvrzeni ACK EEPROM
        ;CHODI
        ;-------
E_ACK:
	setb	EE_DAT			;DAT=1
        lcall   D_PAUZA
	setb	EE_CLK			;CLK=1
        lcall   D_PAUZA
	mov	C,EE_DAT		;EE_DAT=>C
        lcall   D_PAUZA
	clr	EE_CLK			;CLK=0
        lcall   D_PAUZA
	clr	EE_DAT			;DAT=0
	jnc	NECHYBA			;Potvrzeni =>NECHYBA
					;
					; Chyba EEPROM, nepotvrdila data!
					;
        clr     RES
        clr     R_W
        mov     R0,#00000001b           ;Smaz display a DDRAM na 0
        mov     R1,#1d
        lcall   PAUZA                   ;Pauza 50ms
        
        setb	RES
	clr	R_W
	mov	R0,#01000001b		;A
        lcall   D_COMMAND
        mov     R0,#01000011b           ;C
        lcall   D_COMMAND
        mov     R0,#01001011b           ;K
        lcall   D_COMMAND
        mov     R0,#00101101b           ;-
        lcall   D_COMMAND
        mov     R0,#01000101b           ;E
        lcall   D_COMMAND
        mov     R0,#01010010b           ;R
        lcall   D_COMMAND
        mov     R0,#01010010b           ;R
        lcall   D_COMMAND
        mov     R0,#00101110b           ;.
        lcall   D_COMMAND
        clr     RES
        clr     R_W
        mov     R0,#11000000b           ;Druha radka
        lcall   D_COMMAND
        setb	RES
	clr	R_W
        mov     R0,#01000101b           ;E
        lcall   D_COMMAND
        mov     R0,#01000101b           ;E
        lcall   D_COMMAND
        mov     R0,#01010000b           ;P
        lcall   D_COMMAND
        mov     R0,#01010010b           ;R
        lcall   D_COMMAND
        mov     R0,#01001111b           ;O
        lcall   D_COMMAND
        mov     R0,#01001101b           ;M
        lcall   D_COMMAND

        mov     R1,#20d
        lcall   PAUZA                   ;Pauza 1s
        lcall   M_VYP_ANO               ;Vypni LCD a napajeni

NECHYBA:
        lcall   D_PAUZA
	RET

;---------------------------------------------------------------------------
	;Zastaveni prenosu STOP EEPROM
        ;CHODI
        ;-------
E_STOP:
	setb	EE_CLK			;CLK=1
        lcall   D_PAUZA
	setb	EE_DAT			;DAT=1
        lcall   D_PAUZA
	RET

;---------------------------------------------------------------------------
	;Potvrzeni NACK EEPROM
        ;CHODI
        ;-------
E_NACK:
	setb	EE_DAT			;DAT=1
        lcall   D_PAUZA
	setb	EE_CLK			;CLK=1
        lcall   D_PAUZA
	clr	EE_CLK			;CLK=0
        lcall   D_PAUZA
	clr	EE_DAT			;DAT=0
        lcall   D_PAUZA
	RET

;---------------------------------------------------------------------------
	;Cteni dat z EEPROM
        ;CHODI
        ;-------
E_READ:
	mov	TEMP2,#8h		;TEMP2=pocet opakovani 8x
	clr	A			;Vynuluj A
	setb	EE_DAT			;DAT=1, vstup
        lcall   D_PAUZA
REC1:	setb	EE_CLK			;CLK=1
        lcall   D_PAUZA
	mov	C,EE_DAT		;DAT=>C
	rlc	A			;Rotace A pres C
        lcall   D_PAUZA
	clr	EE_CLK			;CLK=0
        lcall   D_PAUZA
	djnz	TEMP2,REC1		;Neni jeste 8bitu prijmuto
	mov	R0,A			;Presun vysledek A do R0
	RET

;---------------------------------------------------------------------------
	;Posle data na USART
	;Pouziva preruseni 0023h
DATA_OUT:
	jb	SPINAC_T,NENI_ZAS	;SPINAC_T=1 => NENI_ZAS
	jb	BEZI_USART,NENI_ZAS	;Zasunut, USART spusten 1=ANO, 0=NE
					;0=>Jeste nebezi, tak inicializuj
	mov	T2CON,#00110000b	;TCLK,RCLK=TIMER2, TR2=0
        mov     TH2,#0FEh               ;Pocatecni nastaveni citace
        mov     TL2,#0C8h               ;
        mov     RCAP2H,#0FEh            ;0FEC8=65224d=>1.2K Baud
        mov     RCAP2L,#0C8h            ;
	mov	SCON,#01000000b		;Nastaveni serioveho kanalu

        mov     SBUF,#0d                ;Naplneni dat, 0d=MEZERA
	clr	TI			;Smaz priznak preruseni USART
	setb	ES			;Povol preruseni od USARTu
	setb	TR2			;Spust USART
	setb	BEZI_USART		;=1, ze uz bezi =>preskoc pak inic.
        mov     CO,#4d                  ;Abych vysilal cerstva data
NENI_ZAS:
	RET

;---------------------------------------------------------------------------
        ;Vypocita zrychleni na 3desetina cisla
        ;1b=znamenko,8b=cela cast,16b=desetina cast
        ;Pouziva: A,B,R1,|R2,R3,R4|,|R5,R6,R7|
        ;CHODI
        ;-------
ZRYCHLENI:
        mov     A,ZRY_LT1               ;Nizsi T1-L =>A     ------    
        mov     B,#100d                 ;B=100d                   |
        mul     AB                      ;Vynasobi T1-L*100d       |
        mov     VYSL_1,A                ;Nizsi vysledek do VYSL_1 |
        mov     R1,B                    ;Zaloha vyssi do R1       |
        mov     A,ZRY_HT1               ;Vyssi T1-H => A          |Vynasobi
        mov     B,#100d                 ;B=100d                   |100*T1
        mul     AB                      ;Vynasobi T1-H*100d       |
        clr     C                       ;Smaz CARRY               |=>VYSL_3
        addc    A,R1                    ;Secti Nizsi B a R1=>A    |=>VYSL_2
        mov     VYSL_2,A                ;Vysledek do VYSL_2       |=>VYSL_1
        mov     A,B                     ;A=Vyssi byte z nasobeni  |
        addc    A,#0d                   ;Secti A+CARRY            |
        mov     VYSL_3,A                ;Vysledek do VYSL_3 ------

        mov     A,ZRY_LT2               ;Nizsi T2-L =>A     ------    
        mov     B,O_POSUN               ;B=Konstanta okolo 50%=0g |
        mul     AB                      ;Vynasobi T2-L*100d       |
        mov     R2,A                    ;Nizsi vysledek do R2     |
        mov     R1,B                    ;Zaloha vyssi do R1       |
        mov     A,ZRY_HT2               ;Vyssi T2-H => A          |Vynasobi
        mov     B,O_POSUN               ;B=Konstanta okolo 50%=0g |O*T2
        mul     AB                      ;Vynasobi T2-H*100d       |
        clr     C                       ;Smaz CARRY               |=>R4 (H)
        addc    A,R1                    ;Secti Nizsi B a R1=>A    |=>R3
        mov     R3,A                    ;Vysledek do R3           |=>R2 (L)
        mov     A,B                     ;A=Vyssi byte z nasobeni  |
        addc    A,#0d                   ;Secti A+CARRY            |
        mov     R4,A                    ;Vysledek do R4     ------

        clr     C                       ;Smaz CARRY         ------
        mov     A,VYSL_1                ;A=VYSL_1                 |
        subb    A,R2                    ;Odecti VYSL_1-R2         |Rozdil
        mov     VYSL_1,A                ;Rozdil uloz do VYSL_1    |(100*T1
        mov     A,VYSL_2                ;A=VYSL_2                 | - O*T2)
        subb    A,R3                    ;Odecti VYSL_2-R3         |
        mov     VYSL_2,A                ;Rozdil uloz do VYSL_2    |=>VYSL_3
        mov     A,VYSL_3                ;A=VYSL_3                 |=>VYSL_2
        subb    A,R4                    ;Odecti VYSL_3-R4         |=>VYSL_1
        mov     VYSL_3,A                ;Rozdil uloz do VYSL_3 ---
	
        clr     ZNAMENKO                ;Predpoklad kladne znamenko

        jnc     JE_MENSI_R              ;CARRY=0 => neni zaporne
        setb    ZNAMENKO                ;Je zaporne

        mov     A,VYSL_1                ;A=VYSL_1       ----------
        cpl     A                       ;Doplnek A                |
        mov     VYSL_1,A                ;VYSL_1=doplnek           |
        mov     A,VYSL_2                ;A=VYSL_2                 |
        cpl     A                       ;Doplnek A                |
        mov     VYSL_2,A                ;VYSL_2=doplnek           |
        mov     A,VYSL_3                ;A=VYSL_3                 |Obnov
        cpl     A                       ;Doplnek A                |spravny
        mov     VYSL_3,A                ;VYSL_3=doplnek           |vysledek
        setb    C                       ;Nastav CARRY             |
        mov     A,VYSL_1                ;A=VYSL_1                 |=>VYSL_3
        addc    A,#0d                   ;A=VYSL_1+1               |=>VYSL_2
        mov     VYSL_1,A                ;VYSL_1=jednot. doplnek   |=>VYSL_1
        mov     A,VYSL_2                ;A=VYSL_2                 |
        addc    A,#0d                   ;A=VYSL_2+CARRY           |
        mov     VYSL_2,A                ;VYSL_2=A+prenos          |
        mov     A,VYSL_3                ;A=VYSL_3                 |
        addc    A,#0d                   ;A=VYSL_3+CARRY           |
        mov     VYSL_3,A                ;VYSL_3=A       ----------                 

JE_MENSI_R:
        mov     A,VYSL_1                ;A=VYSL_1   --------------
        mov     B,#10d                  ;B=10d                    |
        mul     AB                      ;Vynasob VYSL_1*10        |
        mov     VYSL_1,A                ;VYSL_1=Nizsi byte        |
        mov     R1,B                    ;Zaloha Vyssiho bytu      |
        mov     A,VYSL_2                ;A=VYSL_2                 |
        mov     B,#10d                  ;B=10d                    |Vynasobi
        mul     AB                      ;Vynasob VYSL_2*10        |10*(100
        clr     C                       ;Smaz CARRY               |*T1-O*
        addc    A,R1                    ;Secti Nizsi byte a R1    |T2)
        mov     VYSL_2,A                ;Vysledek do VYSL_2       |
        mov     A,B                     ;A=Vyssi byte             |=>VYSL_3
        addc    A,#0d                   ;A=A+0+CARRY              |=>VYSL_2
        mov     R1,A                    ;Zaloha vysledku do R1    |=>VYSL_1
        mov     A,VYSL_3                ;A=VYSL_3                 |
        mov     B,#10d                  ;B=10d                    |
        mul     AB                      ;Vynasob VYSL_3 a 10d     |
        clr     C                       ;Smaz CARRY               |
        addc    A,R1                    ;Secti Nizsi byte a R1    |
        mov     VYSL_3,A                ;VYSL_3=A    -------------

        mov     A,ZRY_LT2               ;A=T2-L    ---------------
        mov     B,X_POSUN               ;B=X_POSUN (okolo 12.5%)  |
        mul     AB                      ;Vynasob A a B            |
        mov     R2,A                    ;R2=Nizsi byte            |
        mov     R1,B                    ;Zaloha R1=Vyssi byte     |Vynasobi
        mov     A,ZRY_HT2               ;A=T2-H                   |T2*X
        mov     B,X_POSUN               ;B=X_POSUN                |
        mul     AB                      ;Vynasob A a B            |=>R4
        clr     C                       ;Smaz CARRY               |=>R3
        addc    A,R1                    ;Secti R1+A               |=>R2
        mov     R3,A                    ;R3=A                     |
        mov     A,B                     ;A=B                      |
        addc    A,#0d                   ;Secti A+0+CARRY          |
        mov     R4,A                    ;R4=Vysledek A  ----------

;------- DELENI NA CELOU A DESETINOU CAST NA 3 MISTA -----------------------
	
        mov     POCET_C,#0d             ;Vynuluj POCET_C
        mov     DESETC_L,#0d            ;Desetine cislo-L =0
        mov     DESETC_H,#0d            ;Desetine cislo-H =0
        mov     DES_C,#0d               ;Vynuluj DES_C

DEL_ZNOVA:
        clr     C                       ;Smaz CARRY     ----------
        mov     A,VYSL_1                ;A=VYSL_1                 |
        subb    A,R2                    ;Rozdil VYSL_1 a R2       |
        mov     R5,A                    ;R5=Vysledek A            |Odecet
        mov     A,VYSL_2                ;A=VYSL_2                 |citatel
        subb    A,R3                    ;Rozdil VYSL_2 a R3       |-
        mov     R6,A                    ;R6=Vysledek A            |jmenova.
        mov     A,VYSL_3                ;A=VYSL_3                 |
        subb    A,R4                    ;Rozdil VYSL_3 a R4       |
        mov     R7,A                    ;R7=Vysledek A   ---------
        jc      CIT_JE_MENSI            ;Jestli je citatel mensi
        inc     POCET_C                 ;Kolikrat je jmenov. mensi nez cit.
        mov     VYSL_1,R5               ;Presun VYSL_1=R5
        mov     VYSL_2,R6               ;Presun VYSL_2=R6
        mov     VYSL_3,R7               ;Presun VYSL_3=R7
        ljmp    DEL_ZNOVA               ;Jeste se vejde => znova odecti

CIT_JE_MENSI:
        mov     A,DES_C                 ;Presun A=DES_C
        cjne    A,#0d,JE_CELA           ;Test A!=0 => JE_CELA
	
        mov     A,VYSL_1                ;A=VYSL_1    -------------
        mov     B,#10d                  ;B=10d                    |
        mul     AB                      ;Vynasobi VYSL_1 a 10d    |
        mov     VYSL_1,A                ;VYSL_1=A                 |
        mov     R1,B                    ;R1=Vyssi byte            |
        mov     A,VYSL_2                ;A=VYSL_2                 |
        mov     B,#10d                  ;B=10d                    |Vynasobi
        mul     AB                      ;Vynasobi VYSL_2 a 10d    |10*Zbytek
        clr     C                       ;Smaz CARRY               |
        addc    A,R1                    ;Secti A a R1             |=>VYSL_3
        mov     VYSL_2,A                ;VYSL_2=A                 |=>VYSL_2
        mov     A,B                     ;Presun A=Vyssi byte      |=>VYSL_1
        addc    A,#0d                   ;Secti A=A+0+CARRY        |
        mov     R1,A                    ;R1=A                     |
        mov     A,VYSL_3                ;A=VYSL_3                 |
        mov     B,#10d                  ;B=10d                    |
        mul     AB                      ;Vynasobi VYSL_3 a 10d    |
        clr     C                       ;Smaz CARRY               |
        addc    A,R1                    ;Secti A=A+R1             |
        mov     VYSL_3,A                ;VYSL_3=A  ---------------
	
        inc     DES_C                   ;Zvetsi DES_C =>jine descetine cislo
        mov     CELA_CAST,POCET_C       ;CELA_CAST=POCET_C
        mov     POCET_C,#0d             ;Smaz POCET_C
        ljmp    DEL_ZNOVA               ;Jedeme pocitat desetina cisla

JE_CELA:
        mov     A,DES_C                 ;Presun do A, abych mohl testovat
        cjne    A,#1d,NENI_1            ;Jestli neni 1
        mov     A,#100d                 ;Je 1 => 3 desetine cislo, A=100d
        mov     B,POCET_C               ;B=POCET_C
        mul     AB                      ;Vynasob POCET_C a 100d
        clr     C                       ;Smaz CARRY
        addc    A,DESETC_L              ;Secti A=A+DESETC_L+0
        mov     DESETC_L,A              ;DESETC_L=A
        mov     A,B                     ;A=Vyssi byte B
        addc    A,DESETC_H              ;Secti A=A+DESETC_H+CARRY
        mov     DESETC_H,A              ;DESETC_H=A
        inc     DES_C                   ;Zvys DES_C, dalsi desetine cislo
        mov     POCET_C,#0d             ;POCET_C=0, pocitame od 0

        mov     A,VYSL_1                ;A=VYSL_1    -------------
        mov     B,#10d                  ;B=10d                    |
        mul     AB                      ;Vynasobi VYSL_1 a 10d    |
        mov     VYSL_1,A                ;VYSL_1=A                 |
        mov     R1,B                    ;R1=Vyssi byte            |
        mov     A,VYSL_2                ;A=VYSL_2                 |
        mov     B,#10d                  ;B=10d                    |Vynasobi
        mul     AB                      ;Vynasobi VYSL_2 a 10d    |10*Zbytek
        clr     C                       ;Smaz CARRY               |
        addc    A,R1                    ;Secti A a R1             |=>VYSL_3
        mov     VYSL_2,A                ;VYSL_2=A                 |=>VYSL_2
        mov     A,B                     ;Presun A=Vyssi byte      |=>VYSL_1
        addc    A,#0d                   ;Secti A=A+0+CARRY        |
        mov     R1,A                    ;R1=A                     |
        mov     A,VYSL_3                ;A=VYSL_3                 |
        mov     B,#10d                  ;B=10d                    |
        mul     AB                      ;Vynasobi VYSL_3 a 10d    |
        clr     C                       ;Smaz CARRY               |
        addc    A,R1                    ;Secti A=A+R1             |
        mov     VYSL_3,A                ;VYSL_3=A  ---------------
        ljmp    DEL_ZNOVA               ;Delim dalsi desetine cislo

NENI_1:
        cjne    A,#2d,NENI_2            ;Test jestli A!=2 =>NENI_2
        mov     A,#10d                  ;Je 2, A=10, 2 Desetine cislo
        mov     B,POCET_C               ;B=POCET_C
        mul     AB                      ;Vynasobi POCET_C a 10d
        clr     C                       ;Smaz CARRY
        addc    A,DESETC_L              ;A=A+DESETC_L+0
        mov     DESETC_L,A              ;DESETC_L=A
        mov     A,DESETC_H              ;A=DESETC_H
        addc    A,#0d                   ;A=A+0+CARRY
        mov     DESETC_H,A              ;DESETC_H=A
        inc     DES_C                   ;Zvys DES_C na dalsi desetine cislo
        mov     POCET_C,#0d             ;Vynuluj POCET_C na dalsi citani

        mov     A,VYSL_1                ;A=VYSL_1    -------------
        mov     B,#10d                  ;B=10d                    |
        mul     AB                      ;Vynasobi VYSL_1 a 10d    |
        mov     VYSL_1,A                ;VYSL_1=A                 |
        mov     R1,B                    ;R1=Vyssi byte            |
        mov     A,VYSL_2                ;A=VYSL_2                 |
        mov     B,#10d                  ;B=10d                    |Vynasobi
        mul     AB                      ;Vynasobi VYSL_2 a 10d    |10*Zbytek
        clr     C                       ;Smaz CARRY               |
        addc    A,R1                    ;Secti A a R1             |=>VYSL_3
        mov     VYSL_2,A                ;VYSL_2=A                 |=>VYSL_2
        mov     A,B                     ;Presun A=Vyssi byte      |=>VYSL_1
        addc    A,#0d                   ;Secti A=A+0+CARRY        |
        mov     R1,A                    ;R1=A                     |
        mov     A,VYSL_3                ;A=VYSL_3                 |
        mov     B,#10d                  ;B=10d                    |
        mul     AB                      ;Vynasobi VYSL_3 a 10d    |
        clr     C                       ;Smaz CARRY               |
        addc    A,R1                    ;Secti A=A+R1             |
        mov     VYSL_3,A                ;VYSL_3=A  ---------------
        ljmp    DEL_ZNOVA               ;Delim dalsi desetine cislo

NENI_2:
        clr     C                       ;Smaz CARRY, Je to 1 desetine cislo
        mov     A,DESETC_L              ;A=DESETC_L
        addc    A,POCET_C               ;A=A+POCET_C+0
        mov     DESETC_L,A              ;DESETC_L=A
        mov     A,DESETC_H              ;A=DESETC_H
        addc    A,#0d                   ;A=A+0+CARRY
        mov     DESETC_H,A              ;DESETC_H=A, Uz je vsechno naplneno
        RET

;---------------------------------------------------------------------------
	;Vypocita posunuti nuly (A=0g)
	;Vstup: DTXL_T1,DTXH_T1,DTXL_T2,DTXH_T2 =>vstupni hodnoty zachovava
	;Modifikuje: A,B,R1,|R4,R3,R2|,|R7,R6,R5|,POCET_C
	;Nastavuje: O_POSUN
        ;CHODI
        ;-------

	;Pouziti:
	;	=> Otoc na danou stranu
	;	=> Pockej 5 vterin
        ;       => Zakaz preruseni vsechna
	;	=> Odecti DTXX_T1, DTXX_T2
	;	=> Zavolej NASTAV_O_POSUN
	;	=> Hotovo, uloz O_POSUN do EEPROM
	;	=> Pockej 5 vterin
        ;       => Povol preruseni
	;	=> Otoc normalne

NASTAV_O_POSUN:
        mov     A,ZRY_LT1               ;A=DTXL_T1      ----------
	mov	B,#10d			;B=10d			  |
	mul	AB			;Vynasobi DTXL_T1*10	  |
	mov	R2,A			;Nejnizsi byte=R2	  |Vynasobi
	mov	R1,B			;R1=vyssi byte, zaloha	  |T1*10
        mov     A,ZRY_HT1               ;A=DTXH_T1                |nebot T1
	mov	B,#10d			;B=10d			  |je vzdy
	mul	AB			;Vynasobi DTXH_T1*10d	  |mensi nez
	clr	C			;Smaz CARRY		  |T2
	addc	A,R1			;Secti nizsi byte+R1+0	  |
	mov	R3,A			;Prostredni byte=R3	  |=>R4
	mov	A,B			;A=vyssi byte=B		  |=>R3
	addc	A,#0d			;Secti A=A+0+CARRY	  |=>R2
	mov	R4,A			;Nejvyssi byte=R4  -------

	mov	POCET_C,#0d		;Vynuluj POCET_C

T1_DEL_ZNOVA:
	clr	C			;Smaz CARRY	----------
	mov	A,R2			;A=R2			  |
        subb    A,ZRY_LT2               ;A=DTXL_T2-R2-0           |
	mov	R5,A			;Vysledek L =>R5	  |Postupne
	mov	A,R3			;A=R3			  |odcitani
        subb    A,ZRY_HT2               ;A=DTXH_T2-R3-CARRY       |=>deleni
	mov	R6,A			;Vysledek M =>R6	  |
	mov	A,R4			;A=R4			  |
	subb	A,#0d			;A=R4-0-CARRY		  |
	mov	R7,A			;Vysledek H =>R7   -------
	jc	T1_JE_10		;Pretekl jsem? Ano skoc.
	inc	POCET_C			;NE, zvys POCET_C
	mov	A,R5			;A=R5
	mov	R2,A			;Presun R2=R5
	mov	A,R6			;A=R6
	mov	R3,A			;Presun R3=R6
	mov	A,R7			;A=R7
	mov	R4,A			;Presun R4=R7
        ljmp    T1_DEL_ZNOVA            ;Opakuj znova

T1_JE_10:
	mov	A,#10d			;A=10d
	mov	B,POCET_C		;B=POCET_C
	mul	AB			;Vynasobi POCET_C*10d
	mov	O_POSUN,A		;Vysledek uloz do O_POSUN

        mov     A,R2                    ;A=R2        -------------
        mov     B,#10d                  ;B=10d                    |
        mul     AB                      ;Vynasobi R2 a 10d        |
        mov     R2,A                    ;R2=A                     |
        mov     R1,B                    ;R1=Vyssi byte            |
        mov     A,R3                    ;A=R3                     |
        mov     B,#10d                  ;B=10d                    |Vynasobi
        mul     AB                      ;Vynasobi R3 a 10d        |10*Zbytek
        clr     C                       ;Smaz CARRY               |
        addc    A,R1                    ;Secti A a R1             |=>R4
        mov     R3,A                    ;R3=A                     |=>R3
        mov     A,B                     ;Presun A=Vyssi byte      |=>R2
        addc    A,#0d                   ;Secti A=A+0+CARRY        |
        mov     R1,A                    ;R1=A                     |
        mov     A,R4                    ;A=R4                     |
        mov     B,#10d                  ;B=10d                    |
        mul     AB                      ;Vynasobi R4 a 10d        |
        clr     C                       ;Smaz CARRY               |
        addc    A,R1                    ;Secti A=A+R1             |
        mov     R4,A                    ;R4=A      ---------------

        mov     POCET_C,#0d             ;Vynuluj POCET_C

T1_DEL2_ZNOVA:
        clr     C                       ;Smaz CARRY   ------------
        mov     A,R2                    ;A=R2                     |
        subb    A,ZRY_LT2               ;A=R2-DTXL_T2-0           |
        mov     R5,A                    ;L R5=A                   |Postupne
        mov     A,R3                    ;A=R3                     |odcitani
        subb    A,ZRY_HT2               ;A=R3-DTXH_T2-CARRY       |=>deleni
        mov     R6,A                    ;M R6=A                   |
        mov     A,R4                    ;A=R4                     |
        subb    A,#0d                   ;A=R4-0-CARRY             |
        mov     R7,A                    ;H R7=A    ---------------
        jnc     T1_JE_1                 ;Test zda jsem jeste vetsi
        mov     A,O_POSUN               ;Nejsem, A=O_POSUN
        add     A,POCET_C               ;A=O_POSUN+POCET_C
        mov     O_POSUN,A               ;Vysledek O_POSUN=A
        RET
T1_JE_1:
        inc     POCET_C                 ;Zvys POCET_C
	mov	A,R5			;A=R5
        mov     R2,A                    ;Presun R2=R5
	mov	A,R6			;A=R6
        mov     R3,A                    ;Presun R3=R6
	mov	A,R7			;A=R7
        mov     R4,A                    ;Presun R4=R7
        ljmp    T1_DEL2_ZNOVA           ;Neni jeste dodeleno

;---------------------------------------------------------------------------
        ;Deleni T1/T2
        ;Vstup: Nekolikrat DXT1_H,DXT1_L,DXT2_H,DXT2_L
        ;Pouziva: |R4,R3,R2|,|R7,R6,R5|,VYSL_1,VYSL_2,VYSL_3,VYSL_4
        ;Vystup: X_POSUN
	;CHODI
	;-------

	;Pouziti:
        ;       NASTAV_X_POSUN:
	;	=> Otoc na 1 stranu
	;	=> Pockej 5 vterin
        ;       => DELENI_T1_T2
        ;       => VYSL_4=VYSL_2, VYSL_3=VYSL_1
	;	=> Otoc na 2 stranu
	;	=> Pockej 5 vterin
        ;       => DELENI_T1_T2
        ;       => Odecet/2
	;	=> Uloz do EEPROM

DELENI_T1_T2:
        mov     A,ZRY_LT1               ;A=DTXL_T1      ----------
	mov	B,#10d			;B=10d			  |
	mul	AB			;Vynasobi DTXL_T1*10	  |
	mov	R2,A			;Nejnizsi byte=R2	  |Vynasobi
	mov	R1,B			;R1=vyssi byte, zaloha	  |T1*10
        mov     A,ZRY_HT1               ;A=DTXH_T1                |nebot T1
	mov	B,#10d			;B=10d			  |je vzdy
	mul	AB			;Vynasobi DTXH_T1*10d	  |mensi nez
	clr	C			;Smaz CARRY		  |T2
	addc	A,R1			;Secti nizsi byte+R1+0	  |
	mov	R3,A			;Prostredni byte=R3	  |=>R4
	mov	A,B			;A=vyssi byte=B		  |=>R3
	addc	A,#0d			;Secti A=A+0+CARRY	  |=>R2
	mov	R4,A			;Nejvyssi byte=R4  -------

	mov	POCET_C,#0d		;Vynuluj POCET_C

C_DEL_ZNOVA:
	clr	C			;Smaz CARRY	----------
	mov	A,R2			;A=R2			  |
        subb    A,ZRY_LT2               ;A=DTXL_T2-R2-0           |
	mov	R5,A			;Vysledek L =>R5	  |Postupne
	mov	A,R3			;A=R3			  |odcitani
        subb    A,ZRY_HT2               ;A=DTXH_T2-R3-CARRY       |=>deleni
	mov	R6,A			;Vysledek M =>R6	  |
	mov	A,R4			;A=R4			  |
	subb	A,#0d			;A=R4-0-CARRY		  |
	mov	R7,A			;Vysledek H =>R7   -------
        jc      C_JE_100                ;Pretekl jsem? Ano skoc.
	inc	POCET_C			;NE, zvys POCET_C
	mov	A,R5			;A=R5
	mov	R2,A			;Presun R2=R5
	mov	A,R6			;A=R6
	mov	R3,A			;Presun R3=R6
	mov	A,R7			;A=R7
	mov	R4,A			;Presun R4=R7
        ljmp    C_DEL_ZNOVA             ;Opakuj znova

C_JE_100:
        mov     A,#100d                 ;A=100d
	mov	B,POCET_C		;B=POCET_C
        mul     AB                      ;Vynasobi POCET_C*100d
        mov     VYSL_2,B                ;Vyssi byte uloz do VYSL_2
        mov     VYSL_1,A                ;Nizsi byte uloz do VYSL_1

        mov     A,R2                    ;A=R2        -------------
        mov     B,#10d                  ;B=10d                    |
        mul     AB                      ;Vynasobi R2 a 10d        |
        mov     R2,A                    ;R2=A                     |
        mov     R1,B                    ;R1=Vyssi byte            |
        mov     A,R3                    ;A=R3                     |
        mov     B,#10d                  ;B=10d                    |Vynasobi
        mul     AB                      ;Vynasobi R3 a 10d        |10*Zbytek
        clr     C                       ;Smaz CARRY               |
        addc    A,R1                    ;Secti A a R1             |=>R4
        mov     R3,A                    ;R3=A                     |=>R3
        mov     A,B                     ;Presun A=Vyssi byte      |=>R2
        addc    A,#0d                   ;Secti A=A+0+CARRY        |
        mov     R1,A                    ;R1=A                     |
        mov     A,R4                    ;A=R4                     |
        mov     B,#10d                  ;B=10d                    |
        mul     AB                      ;Vynasobi R4 a 10d        |
        clr     C                       ;Smaz CARRY               |
        addc    A,R1                    ;Secti A=A+R1             |
        mov     R4,A                    ;R4=A      ---------------

        mov     POCET_C,#0d             ;Vynuluj POCET_C

C2_DEL_ZNOVA:
	clr	C			;Smaz CARRY	----------
	mov	A,R2			;A=R2			  |
        subb    A,ZRY_LT2               ;A=DTXL_T2-R2-0           |
	mov	R5,A			;Vysledek L =>R5	  |Postupne
	mov	A,R3			;A=R3			  |odcitani
        subb    A,ZRY_HT2               ;A=DTXH_T2-R3-CARRY       |=>deleni
	mov	R6,A			;Vysledek M =>R6	  |
	mov	A,R4			;A=R4			  |
	subb	A,#0d			;A=R4-0-CARRY		  |
	mov	R7,A			;Vysledek H =>R7   -------
        jc      C_JE_10                 ;Pretekl jsem? Ano skoc.
	inc	POCET_C			;NE, zvys POCET_C
	mov	A,R5			;A=R5
	mov	R2,A			;Presun R2=R5
	mov	A,R6			;A=R6
	mov	R3,A			;Presun R3=R6
	mov	A,R7			;A=R7
	mov	R4,A			;Presun R4=R7
        ljmp    C2_DEL_ZNOVA            ;Opakuj znova

C_JE_10:
        mov     A,#10d                  ;A=10d
	mov	B,POCET_C		;B=POCET_C
        mul     AB                      ;Vynasobi POCET_C*10d
        add     A,VYSL_1                ;A=A+VYSL_1
        mov     VYSL_1,A                ;VYSL_1=A
        mov     A,B                     ;Presun B do A
        addc    A,VYSL_2                ;A=A+VYSL_2+CARRY
        mov     VYSL_2,A                ;VYSL_2=A

        mov     A,R2                    ;A=R2        -------------
        mov     B,#10d                  ;B=10d                    |
        mul     AB                      ;Vynasobi R2 a 10d        |
        mov     R2,A                    ;R2=A                     |
        mov     R1,B                    ;R1=Vyssi byte            |
        mov     A,R3                    ;A=R3                     |
        mov     B,#10d                  ;B=10d                    |Vynasobi
        mul     AB                      ;Vynasobi R3 a 10d        |10*Zbytek
        clr     C                       ;Smaz CARRY               |
        addc    A,R1                    ;Secti A a R1             |=>R4
        mov     R3,A                    ;R3=A                     |=>R3
        mov     A,B                     ;Presun A=Vyssi byte      |=>R2
        addc    A,#0d                   ;Secti A=A+0+CARRY        |
        mov     R1,A                    ;R1=A                     |
        mov     A,R4                    ;A=R4                     |
        mov     B,#10d                  ;B=10d                    |
        mul     AB                      ;Vynasobi R4 a 10d        |
        clr     C                       ;Smaz CARRY               |
        addc    A,R1                    ;Secti A=A+R1             |
        mov     R4,A                    ;R4=A      ---------------

        mov     POCET_C,#0d             ;Vynuluj POCET_C

C3_DEL_ZNOVA:
	clr	C			;Smaz CARRY	----------
	mov	A,R2			;A=R2			  |
        subb    A,ZRY_LT2               ;A=DTXL_T2-R2-0           |
	mov	R5,A			;Vysledek L =>R5	  |Postupne
	mov	A,R3			;A=R3			  |odcitani
        subb    A,ZRY_HT2               ;A=DTXH_T2-R3-CARRY       |=>deleni
	mov	R6,A			;Vysledek M =>R6	  |
	mov	A,R4			;A=R4			  |
	subb	A,#0d			;A=R4-0-CARRY		  |
	mov	R7,A			;Vysledek H =>R7   -------
        jc      C_JE_1                  ;Pretekl jsem? Ano skoc.
	inc	POCET_C			;NE, zvys POCET_C
	mov	A,R5			;A=R5
	mov	R2,A			;Presun R2=R5
	mov	A,R6			;A=R6
	mov	R3,A			;Presun R3=R6
	mov	A,R7			;A=R7
	mov	R4,A			;Presun R4=R7
        ljmp    C3_DEL_ZNOVA            ;Opakuj znova

C_JE_1:
        mov     A,POCET_C               ;A=POCET_C
        add     A,VYSL_1                ;A=A+VYSL_1
        mov     VYSL_1,A                ;VYSL_1=A
        mov     A,VYSL_2                ;A=VYSL_2
        addc    A,#0d                   ;A=VYSL_2+0+CARRY
        mov     VYSL_2,A                ;VYSL_2=A
        RET
        
;---------------------------------------------------------------------------
	;Zobrazi na disleji 8 mistne cislo
	;Vstup: Neco v R4(H),R3(M),R2(L)
        ;Pozice vystupu je nastavena predchozim zobrazenim

ZOB_8CISLA:
        mov     POCET_C,#0d             ;Vynuluj POCET_C
        mov     DES_C,#0d               ;Vynuluj DES_C
        setb    TEMP_B                  ;Ze budu testovan na 0

Z_10000000:
        clr     C                       ;Smaz CARRY
        mov     A,R2                    ;A=R2
        subb    A,#80h                  ;A=A-R2-0-80h =>10000000d
        mov     R5,A                    ;Vysledek do R5
        mov     A,R3                    ;A=R3
        subb    A,#96h                  ;A=A-R3-CARRY-96h
        mov     R6,A                    ;Vysledek do R6
        mov     A,R4                    ;A=R4
        subb    A,#98h                  ;A=A-R4-CARRY-98h
        mov     R7,A                    ;Vysledek do R7
        jc      NE_10000000             ;Jestli dalsi odcitani
        inc     POCET_C                 ;Zvys o jednicku
        mov     A,R5                    ;Presun R2=R5
        mov     R2,A                    ;
        mov     A,R6                    ;Presun R3=R6
        mov     R3,A                    ;
        mov     A,R7                    ;Presun R4=R7
        mov     R4,A                    ;
        ljmp    Z_10000000              ;Opakuj odcitani

NE_10000000:                            
        mov     A,POCET_C               ;Abych mohl otestovat
        jnz     NE_80                   ;Neni nula
        jnb     TEMP_B,NE_80            ;Test jestli ma byt jeste 0
        mov     R0,#00100000b           ;Mezera
        ljmp    NE_8X                   ;Preskoc zbytek
NE_80:
        clr     TEMP_B                  ;Aby uz byla 0
        orl     A,#00110000B            ;Vymaskovani
        mov     R0,A                    ;Zapis do R0 (data pro display)
NE_8X:
	setb	RES
	clr	R_W
        lcall   D_COMMAND               ;Zobraz
        mov     POCET_C,#0d             ;Vynuluj

Z_1000000:
        clr     C                       ;Smaz CARRY
        mov     A,R2                    ;A=R2
        subb    A,#40h                  ;A=R2-40h-0 =>1000000d
        mov     R5,A                    ;Vysledek do R5
        mov     A,R3                    ;A=R3
        subb    A,#42h                  ;A=R3-42-CARRY
        mov     R6,A                    ;Vysledek do R6
        mov     A,R4                    ;A=R4
        subb    A,#0Fh                  ;A=R4-0Fh-CARRY
        mov     R7,A                    ;Vysledek do R7
        jc      NE_1000000              ;Mam jeste co odcitat?
        inc     POCET_C                 ;Zvys kolikrat jsem delil
        mov     A,R5                    ;Presun R2=R5
        mov     R2,A                    ;
        mov     A,R6                    ;Presun R3=R6
        mov     R3,A                    ;
        mov     A,R7                    ;Presun R4=R7
        mov     R4,A                    ;
        ljmp    Z_1000000               ;Jinak opakuj

NE_1000000:
        mov     A,POCET_C               ;A=POCET_C (kolikrat)
        jnz     NE_70                   ;A!=0 => jina cislice
        jnb     TEMP_B,NE_70            ;Test jestli ma byt jeste 0
        mov     R0,#00100000b           ;Mezera
        ljmp    NE_7X                   ;Preskoc nepotrebne
NE_70:
        clr     TEMP_B                  ;Aby uz byla 0
        orl     A,#00110000B            ;Vymaskuj na LCD
        mov     R0,A                    ;Presun data
NE_7X:
        lcall   D_COMMAND               ;Posli na LCD
        mov     POCET_C,#0d             ;Vynuluj
Z_100000:
        clr     C                       ;Smaz CARRY
        mov     A,R2                    ;A=R2
        subb    A,#0A0h                 ;A=R2-0A0h-0 =>100000
        mov     R5,A                    ;Vysledek do R5
        mov     A,R3                    ;A=R3
        subb    A,#86h                  ;A=R3-86h-CARRY
        mov     R6,A                    ;Vysledek do R6
        mov     A,R4                    ;A=R4
        subb    A,#01h                  ;A=R4-01h-CARRY
        mov     R7,A                    ;Vysledek do R7
        jc      NE_100000               ;Jeste delit?
        inc     POCET_C                 ;Zvys pocet deleni o 1
        mov     A,R5                    ;Presun R2=R5
        mov     R2,A                    ;
        mov     A,R6                    ;Presun R3=R6
        mov     R3,A                    ;
        mov     A,R7                    ;Presun R4=R7
        mov     R4,A                    ;
        ljmp    Z_100000                ;Jinak opakuj

NE_100000:
        mov     A,POCET_C               ;A=POCET_C
        jnz     NE_60                   ;A!=0 => nejake cislo
        jnb     TEMP_B,NE_60            ;Test jestli ma byt jeste 0
        mov     R0,#00100000b           ;Mezera
        ljmp    NE_6X                   ;Nehodici preskoc
NE_60:
        clr     TEMP_B                  ;Aby uz byla 0
        orl     A,#00110000B            ;Vymaskuj
        mov     R0,A                    ;R0= data na LCD
NE_6X:
        lcall   D_COMMAND               ;Zobraz
        mov     POCET_C,#0d             ;Vynuluj
Z_10000:
        clr     C                       ;Smaz CARRY
        mov     A,R2                    ;A=R2
        subb    A,#10h                  ;A=R2-10h-0 => 10000
        mov     R5,A                    ;Vysledek do R5
        mov     A,R3                    ;A=R3
        subb    A,#27h                  ;A=R3-27h-CARRY
        mov     R6,A                    ;Vysledek do R6
        mov     A,R4                    ;A=R4
        subb    A,#0d                   ;A=R4-0-CARRY
        mov     R7,A                    ;Vysledek do R7
        jc      NE_10000                ;Neco delit?
        inc     POCET_C                 ;Ano, pricti jednicku
        mov     A,R5                    ;Presun R2=R5
        mov     R2,A                    ;
        mov     A,R6                    ;Presun R3=R6
        mov     R3,A                    ;
        mov     A,R7                    ;Presun R4-R7
        mov     R4,A                    ;
        ljmp    Z_10000                 ;Opet opakuj

NE_10000:
        mov     A,POCET_C               ;A=pocet deleni POCET_C
        jnz     NE_50                   ;A!=0 =>NE_50 => jina cislice
        jnb     TEMP_B,NE_50            ;Test jestli ma byt jeste 0
        mov     R0,#00100000b           ;Mezera
        ljmp    NE_5X                   ;Ostatni preskoc
NE_50:
        clr     TEMP_B                  ;Aby uz byla 0
        orl     A,#00110000B            ;Vymaskovani pro LCD
        mov     R0,A                    ;R0= data LCD
NE_5X:
        lcall   D_COMMAND               ;Zobraz na LCD
        mov     POCET_C,#0d             ;Vynuluj pocet, abych mohl znova
Z_1000:
        clr     C                       ;Smaz CARRY
        mov     A,R2                    ;A=R2
        subb    A,#0E8h                 ;A=R2-0E8h-0 => 1000
        mov     R5,A                    ;Vysledek do R5
        mov     A,R3                    ;A=R3
        subb    A,#03h                  ;A=R3-0h-CARRY
        mov     R6,A                    ;Vysledek do R6
        mov     A,R4                    ;A=R4
        subb    A,#0d                   ;A=R4-0-CARRY
        mov     R7,A                    ;Vysledek do R7
        jc      NE_1000                 ;Jeste delit?
        inc     POCET_C                 ;Zvys POCET_C o jednicku
        mov     A,R5                    ;Presun R2=R5
        mov     R2,A                    ;
        mov     A,R6                    ;Presun R3=R6
        mov     R3,A                    ;
        mov     A,R7                    ;Presun R4=R7
        mov     R4,A                    ;
        ljmp    Z_1000                  ;Jinak pokracuj znova

NE_1000:
        mov     A,POCET_C               ;A=POCET_C
        jnz     NE_40                   ;A!=0 => nejaka cislice krome 0
        jnb     TEMP_B,NE_40            ;Test jestli ma byt jeste 0
        mov     R0,#00100000b           ;Mezera
        ljmp    NE_4X                   ;Nehodici preskoc
NE_40:
        clr     TEMP_B                  ;Aby uz byla 0
        orl     A,#00110000B            ;Vymaskuj
        mov     R0,A                    ;Data pro LCD v R0
NE_4X:
        lcall   D_COMMAND               ;Zobraz na LCD
        mov     POCET_C,#0d             ;Vynuluj pocet deleni
Z_100:
        clr     C                       ;Smaz CARRY
        mov     A,R2                    ;A=R2
        subb    A,#100d                 ;A=R2-100d-0 =>100d
        mov     R5,A                    ;Vysledek do R5
        mov     A,R3                    ;A=R3
        subb    A,#0d                   ;A=R3-0-CARRY
        mov     R6,A                    ;Vysledek do R6
        mov     A,R4                    ;A=R4
        subb    A,#0d                   ;A=R4-0-CARRY
        mov     R7,A                    ;Vysledek do R7
        jc      NE_100                  ;Jeste delit?
        inc     POCET_C                 ;Ano, pricti jednicku
        mov     A,R5                    ;Presun R2=R5
        mov     R2,A                    ;
        mov     A,R6                    ;Presun R3=R6
        mov     R3,A                    ;
        mov     A,R7                    ;Presun R4=R7
        mov     R4,A                    ;
        ljmp    Z_100                   ;Jinak preskoc

NE_100:
        mov     A,POCET_C               ;A=POCET_C
        jnz     NE_30                   ;Neni 0 => skoc
        jnb     TEMP_B,NE_30            ;Test jestli ma byt jeste 0
        mov     R0,#00100000b           ;Mezera
        ljmp    NE_3X                   ;Nehodici preskoc
NE_30:
        clr     TEMP_B                  ;Aby uz byla 0
        orl     A,#00110000B            ;Vymaskuj pro LCD
        mov     R0,A                    ;R0= data pro LCD
NE_3X:
        lcall   D_COMMAND               ;Zobraz na LCD
        mov     POCET_C,#0d             ;POCET_C=0
Z_10:
        clr     C                       ;Nastav CARRY na 0
        mov     A,R2                    ;Presun R2 do A
        subb    A,#10d                  ;Odecti od toho 10d (L)
        mov     R5,A                    ;Vysledek do R5
        mov     A,R3                    ;A=R3
        subb    A,#0d                   ;Odecti CARRY
        mov     R6,A                    ;Vysledek do R6
        mov     A,R4                    ;A=R4
        subb    A,#0d                   ;Odecti CARRY
        mov     R7,A                    ;Vysledek do R7
        jc      NE_10                   ;Bude se jeste odcitat?
        inc     POCET_C                 ;Ano, POCET_C+1
        mov     A,R5                    ;Presun R2=R5
        mov     R2,A                    ;
        mov     A,R6                    ;Presun R3=R6
        mov     R3,A                    ;
        mov     A,R7                    ;Presun R4=R7
        mov     R4,A                    ;
        ljmp    Z_10                    ;Jeste delim

NE_10:
        mov     A,POCET_C               ;A=POET_C
        jnz     NE_20                   ;Neni 0 => skoc
        jnb     TEMP_B,NE_20            ;Test jestli ma byt jeste 0
        mov     R0,#00100000b           ;Mezera
        ljmp    NE_2X                   ;Ostatni preskoc
NE_20:
        clr     TEMP_B                  ;Aby uz byla 0
        orl     A,#00110000B            ;Vymaskovani pro cislice LCD
        mov     R0,A                    ;R0=data pro LCD
NE_2X:
        lcall   D_COMMAND               ;Zobraz na LCD
        mov     POCET_C,R2              ;Jednotky rovnou do POCET_C
	
        mov     A,POCET_C               ;A=POCET_C
        orl     A,#00110000b            ;Vymaskuj
        mov     R0,A                    ;R0=data pro LCD
        lcall   D_COMMAND               ;Zobraz
        RET                             ;Navrat z procedury

;---------------------------------------------------------------------------
        ;Zobrazi na disleji 3 mistne cislo
        ;Vstup: DATA_Z

ZOB_3CISLA:
        mov     POCET_C,#0d             ;Vynuluj POCET_C
Z3_100:
        clr     C                       ;Smaz CARRY
        mov     A,DATA_Z                ;A=DATA_Z
        subb    A,#100d                 ;Odecti stovku
        mov     R5,A                    ;Vysledek do R5
        jnc     JE3_100                 ;Jeste del

        mov     A,POCET_C               ;A=POCET_C
        orl     A,#00110000b            ;Vymaskuj
        setb    RES
        clr     R_W
        mov     R0,A                    ;Presun data do R0
        lcall   D_COMMAND               ;Zobraz

        mov     POCET_C,#0d             ;Vynuluj
Z3_10:
        clr     C                       ;Smaz CARRY
        mov     A,DATA_Z                ;A=DATA_Z
        subb    A,#10d                  ;Odecti 10
        mov     R5,A                    ;Vysledek do R5
        jnc     JE3_10                  ;Jeste je co delit

        mov     A,POCET_C               ;A=POCET_C
        orl     A,#00110000b            ;Vymaskuj
        mov     R0,A                    ;Data do R0
        lcall   D_COMMAND               ;Zobraz

        mov     POCET_C,DATA_Z          ;Jednotky primo
	
        mov     A,POCET_C               ;A=POCET_C
        orl     A,#00110000b            ;Vymaskuj
        mov     R0,A                    ;Data v R0
        lcall   D_COMMAND               ;Zobraz
        RET                             ;Konec procedury

JE3_10:
        inc     POCET_C                 ;POCET_C+1
        mov     DATA_Z,R5               ;Presun zbytku do DATA_Z
        ljmp    Z3_10                   ;Znovu

JE3_100:
        inc     POCET_C                 ;POCET_C+1
        mov     DATA_Z,R5               ;Zbytek do DATA_Z
        ljmp    Z3_100                  ;Znovu

;---------------------------------------------------------------------------



;---------------------------------------------------------------------------
        ;Cteni tlacitek a nastaveni stanovenych bitu
        ;Pouziva R2 (BEEP)

TLACITKA:
        clr     ZRUSIT                  ;Smaze nastavajici priznaky
        clr     SIPKA                   ;Smaze nastavajici priznaky
        clr     ENTER                   ;Smaze nastavajici priznaky

        jb      TLAC1,N_ZRUS            ;TLAC1=1 => N_ZRUS
        setb    ZRUSIT                  ;Nastav ZRUSIT
        lcall   BEEP                    ;Pipni
N_ZRUS: jb      TLAC2,N_SIPKA           ;TLAC2=1 => N_SIPKA
        setb    SIPKA                   ;Nastav SIPKA
        lcall   BEEP                    ;Pipni
N_SIPKA:jb      TLAC3,N_ZMAC            ;TLAC3=1 => N_ZMAC
        setb    ENTER                   ;Nastav ENTER
        lcall   BEEP                    ;Pipni
N_ZMAC: RET

;---------------------------------------------------------------------------
	;Zobrazi na displeji 2x8 znaku, ktere jsou uz ulozeny v programu
	;Vstup:	R2=je pouzivan jako vstupni posun
	;Pouziva: R2,R3,A
	;CHODI
	;-------
D_MENU:
	mov	R3,#8d			;Pocet policek displeje

	clr	RES
	clr	R_W
	mov	R0,#10000000b		;Aby vratil kurzor na DDRAM=0h
        lcall   D_COMMAND               ;Zavolej konajici proceduru
	mov	R1,#1d			;R1=1d =>50ms
        lcall   PAUZA                   ;Zavolej pauzu
P_DAL8A:
	mov	A,R2			;A=offset
	mov	DPTR,#D_TEXT		;Segment=D_TEXT
	movc	A,@A+DPTR		;A=Segment+offset

	setb	RES
	clr	R_W
	mov	R0,A			;Prectene cislo z programu do A
        lcall   D_COMMAND               ;Zobraz

	inc	R2			;Zvys offset
	djnz	R3,P_DAL8A		;Je jeste neco poslat

	mov	R3,#8d			;Pocet policek displeje
	
	clr	RES
	clr	R_W
	mov	R0,#11000000b		;Kurzor na zacatek druheho radku
        lcall   D_COMMAND               ;Vykonej prikaz
P_DAL8B:
	mov	A,R2			;A=offset
	mov	DPTR,#D_TEXT		;Segment=D_TEXT
	movc	A,@A+DPTR		;A=Segment+offset

	setb	RES
	clr	R_W
	mov	R0,A			;Prectene cislo z programu do A
        lcall   D_COMMAND               ;Zobraz

	inc	R2			;Zvys offset
	djnz	R3,P_DAL8B		;Je jeste neco poslat
        RET                             ;Navrat

;---------------------------------------------------------------------------
	;Upravi vypoctenou hodnotu na urcitou hladinu a pripise puvodni
	;Vstup: ZNAMENKO,CELA_CAST,DESETC_H,DESETC_L,O_DESETC_H,O_DESETC_L
	;Pouziva: VYSL_4,VYSL_3,VYSL_2,VYSL_1
	;Vystup: DESETC_H,DESETC_L
	;O_DESETC je kladne okolo 1000, nutno predem naplnit!
	;CHODI
	;-------

UPRAV_HLADINU:
	jb	ZNAMENKO,JE_ZAPORNE	;Zaporne=> nezajima me
	mov	A,CELA_CAST		;A=CELA_CAST
	jnz	MOZNA_A1		;A!=0, skoc
	mov	VYSL_3,#0d		;
	mov	VYSL_4,#0d		;VYSL_4,VYSL_3=0d
        ljmp    UZ_NEAX                 ;Uz ne cela
MOZNA_A1:
	dec	A			;Odecti A-1=A
	jnz	MOZNA_A2		;Mozna, ze je A=2
	mov	VYSL_3,#0E8h		;
	mov	VYSL_4,#03h		;VYSL_4,VYSL_3=03E8h=1000d
        ljmp    UZ_NEAX                 ;Uz ne cela
MOZNA_A2:
	mov	VYSL_3,#0D0h		;
	mov	VYSL_4,#07h		;VYSL_4,VYSL_3=07d0h=2000d
UZ_NEAX:
	mov	A,DESETC_L		;A=DESETC_L
	add	A,VYSL_3		;A=DESETC_L+VYSL_3
	mov	VYSL_3,A		;VYSL_3=A
	mov	A,DESETC_H		;A=DESETC_H
	addc	A,VYSL_4		;A=DESETC_H+VYSL_4+CARRY
	mov	VYSL_4,A		;VYSL_4=A

	clr	C			;Smaz CARRY
	mov	A,O_DESETC_L		;A=O_DESETC_L
	subb	A,VYSL_3		;A=O_DESETC_L-VYSL_3-0
	mov	A,O_DESETC_H		;A=O_DESETC_H
	subb	A,VYSL_4		;A=O_DESETC_H-VYSL_4-CARRY
	jnc	JE_ZAPORNE		;C=0 =>, O>namerena

	clr	C			;C=1 =>, O<namerena
	mov	A,VYSL_3		;A=VYSL_3(L)
	subb	A,O_DESETC_L		;A=VYSL_3-O_DESETC_L-0
	mov	DESETC_L,A		;Nahrad DESETC_L=A
	mov	A,VYSL_4		;A=VYSL_4(H)
	subb	A,O_DESETC_H		;A=VYSL_4-O_DESETC_H-CARRY
	mov	DESETC_H,A		;Nahrad DESETC_H=A
	clr	ZNAMENKO		;Smaz znamenko
	mov	CELA_CAST,#0h		;Smaze celou cast, nezajima me
	RET				;Navrat z procedury

JE_ZAPORNE:
	clr	ZNAMENKO		;Smaz znamenko
	mov	CELA_CAST,#0h		;Smaze celou cast, nezajima me
	mov	DESETC_L,#0d		;DESETC_L=0d
	mov	DESETC_H,#0d		;DESETC_H=0d
        RET                             ;Navrat

;---------------------------------------------------------------------------
	;Vypocita klouzavy prumer o dane velikosti
	;Vstup: VELIKOST_D nutno naplnit
	;Pouziva: R0,R1,R2,R3,VYSL_3,VYSL_2,VYSL_1,KONEC_PO
	;Vystup: DESETC_H,DESETC_L
        ;CHODI
        ;-------

KLOUZAVY_PRUMER:
	mov	VYSL_3,#0d		;Vynuluj VYSL_3
	mov	VYSL_2,#0d		;Vynuluj VYSL_2
	mov	VYSL_1,#0d		;Vynuluj VYSL_1
	mov	A,VELIKOST_D		;A=VELIKOST_D
	rlc	A			;Vynasob dvema
	add	A,#80h			;A=80h+2*VELIKOST_D
	mov	KONEC_PO,A		;KONEC_PO=A=konecna adresa nep. adr.
	mov	R0,#80h			;R0=zacatek=80h
JESTE_P_D:
	inc	R0			;Zvys R0
	inc	R0			;Zvys R0
	mov	A,@R0			;A=hodnota na @R0
	mov	R2,A			;R2=@R0
	inc	R0			;Zvys R0
	mov	A,@R0			;A=hodnora na @R0
	mov	R3,A			;R3=@R0

	mov	A,VYSL_1		;A=VYSL_1	----------
	add	A,R2			;A=VYSL_1+R2		  |
	mov	VYSL_1,A		;VYSL_1=A		  |Soucet
	mov	A,VYSL_2		;A=VYSL_2		  |prvku
	addc	A,R3			;A=VYSL_2+R3+CARRY	  |
	mov	VYSL_2,A		;VYSL_2=A		  |=>VYSL_1
	mov	A,VYSL_3		;A=VYSL_3		  |=>VYSL_2
	addc	A,#0d			;A=VYSL_3+0+CARRY	  |=>VYSL_3
	mov	VYSL_3,A		;VYSL_3=A	----------

	dec	R0			;Sniz R0
	dec	R0			;Sniz R0
	mov	A,R3			;A=R3
	mov	@R0,A			;Zapis data na @R0
	dec	R0			;Sniz R0
	mov	A,R2			;A=R2
	mov	@R0,A			;Zapis data na @R0
	inc	R0			;Zvys R0
	inc	R0			;Zvys R0
	mov	A,R0			;A=R0
	cjne	A,KONEC_PO,JESTE_P_D	;Jsi na konci adresy? NE=> skoc
	
	dec	R0			;Sniz R0
	dec	R0			;Sniz R0
	mov	@R0,DESETC_L		;@R0=nova data L
	inc	R0			;Zvys R0
	mov	@R0,DESETC_H		;@R0=nova data H

	mov	A,VYSL_1		;A=VYSL_1	----------
	add	A,DESETC_L		;A=VYSL_1+DESETC_L	  |
	mov	VYSL_1,A		;VYSL_1=A		  |Soucet
	mov	A,VYSL_2		;A=VYSL_2		  |prvku
	addc	A,DESETC_H		;A=VYSL_2+DESETC_H+CARRY  |
	mov	VYSL_2,A		;VYSL_2=A		  |=>VYSL_1
	mov	A,VYSL_3		;A=VYSL_3		  |=>VYSL_2
	addc	A,#0d			;A=VYSL_3+0+CARRY	  |=>VYSL_3
	mov	VYSL_3,A		;VYSL_3=A	----------

	mov	R1,VELIKOST_D		;R1=zaloha VELIKOST_D ----
JESTE_DEL_D:				;			  |
	clr	C			;Smaz CARRY		  |
	mov	A,VYSL_3		;A=VYSL_3		  |
	rrc	A			;Rotace doprava		  |
	mov	VYSL_3,A		;Uloz modifikovane	  |
	mov	A,VYSL_2		;A=VYSL_2		  |Deleni
	rrc	A			;Rotace doprava		  |klouzav.
	mov	VYSL_2,A		;Uloz modifikovane	  |prumeru
	mov	A,VYSL_1		;A=VYSL_1		  |
	rrc	A			;Rotace doprava		  |=>VYSL_1
	mov	VYSL_1,A		;Uloz modifikovane	  |=>VYSL_2
					;			  |
	clr	C			;Smaz CARRY		  |
	mov	A,R1			;A=VELIKOST_D		  |
	rrc	A			;Rotace doprava		  |
	mov	R1,A			;R1=modifikovane A (R1)   |
	cjne	R1,#01d,JESTE_DEL_D	;Jeste deleni => skoc ----
	
	mov	S_DESETC_L,N_DESETC_L	;Zaloha stara hodnota L
	mov	S_DESETC_H,N_DESETC_H	;Zaloha stara hodnota H

	mov	N_DESETC_L,VYSL_1	;Nova data DESETC_L
	mov	N_DESETC_H,VYSL_2	;Nova data DESETC_H
        RET                             ;Navrat

;---------------------------------------------------------------------------
        ;Otestuje na novy krok a pricte kroky a vzdalenost
	;Vstup:	S_DESETC_X,N_DESETC_X
	;Vystup: P_KROK_X,D_TRASY_X

TEST_KROK:
	clr	C			;Smaz CARRY
	mov	A,N_DESETC_L		;A=N_DESETC_L (nova)
	subb	A,S_DESETC_L		;A=N_DESETC_L-S_DESETC_L-0
	mov	A,N_DESETC_H		;A=N_DESETC_H (nova)
	subb	A,S_DESETC_H		;A=N_DESETC_H-S_DESETC_H-CARRY
        jnc     NENI_KRO_0              ;CARRY=0 => neni dalsi krok
        jb      VRCHOL,NENI_KROK        ;

        setb    VRCHOL                  ;
	mov	A,P_KROK_L		;A=P_KROK_L	---------
	addc	A,#0d			;A=P_KROK_L+0+CARRY(1)	 |
	mov	P_KROK_L,A		;P_KROK_L=A (nova)	 |
	mov	A,P_KROK_M		;A=P_KROK_M		 |Zvysuji
	addc	A,#0d			;A=P_KROK_M+0+CARRY	 |pocet
	mov	P_KROK_M,A		;P_KROK_M=A (nova)	 |kroku
	mov	A,P_KROK_H		;A=P_KROK_H		 |
	addc	A,#0d			;A=P_KROK_H+0+CARRY	 |
	mov	P_KROK_H,A		;P_KROK_H=A (nova)    ---

	mov	A,D_TRASY_L		;A=D_TRASY_L	---------
	add	A,D_KROKU		;A=D_TRASY_L+D_KROKU	 |
	mov	D_TRASY_L,A		;D_TRASY_L=A (nova)	 |
	mov	A,D_TRASY_M		;A=D_TRASY_M		 |Zvysuji
	addc	A,#0d			;A=D_TRASY_M+0+CARRY	 |uslou
	mov	D_TRASY_M,A		;D_TRASY_M=A (nova)	 |vzdalenost
	mov	A,D_TRASY_H		;A=D_TRASY_H		 |
	addc	A,#0d			;A=D_TRASY_H+0+CARRY	 |
	mov	D_TRASY_H,A		;D_TRASY_H=A (nova)   ---

        setb    STAV_KROK               ;Ze jsem udelal krok

        clr     C                       ;Smaz CARRY
        mov     A,#40h                  ;A=40h
        subb    A,D_TRASY_L             ;Odecti 13000000
        mov     A,#5Dh                  ;A=5Dh
        subb    A,D_TRASY_M             ;Odecti
        mov     A,#0C6h                 ;A=C6h
        subb    A,D_TRASY_H             ;Odecti
        jnc     NENI_TRA_0              ;Jestli jsem dosahl hladiny
        mov     D_TRASY_L,#0d           ;Ano
        mov     D_TRASY_M,#0d           ;Smaz DELKU TRASY
        mov     D_TRASY_H,#0d           ;

NENI_TRA_0:
        clr     C                       ;Smaz CARRY
        mov     A,#0A0h                 ;A=A0h
        subb    A,P_KROK_L              ;Odecti 100000
        mov     A,#86h                  ;A=86h
        subb    A,P_KROK_M              ;Odecti
        mov     A,#01h                  ;A=01h
        subb    A,P_KROK_H              ;Odecti
        jnc     NENI_KROK               ;Dosahl jsem vrcholu?
        mov     P_KROK_L,#0d            ;Ano
        mov     P_KROK_M,#0d            ;Smaz POCET KROKU
        mov     P_KROK_H,#0d            ;
        RET

NENI_KRO_0:
         clr    VRCHOL                  ;
NENI_KROK:
        RET                             ;Navrat

;---------------------------------------------------------------------------
;---------------------------------------------------------------------------
D_TEXT:
	DB	5Ah,6Fh,62h,72h,61h,7Ah,3Ah,20h		;Zobraz:_
	DB	20h,20h,20h,20h,20h,20h,20h,20h		;________
        DB      54h,72h,61h,73h,61h,20h,20h,31h         ;Trasa__1
        DB      20h,20h,20h,20h,20h,20h,20h,20h         ;________
        DB      4Bh,72h,6Fh,6Bh,79h,20h,20h,32h         ;Kroky__2
        DB      20h,20h,20h,20h,20h,20h,20h,20h         ;________
        DB      53h,6Dh,61h,7Ah,61h,74h,20h,33h         ;Smazat_3
        DB      68h,6Fh,64h,6Eh,6Fh,74h,79h,3Fh         ;hodnoty?
        DB      20h,41h,6Eh,6Fh,20h,20h,20h,20h         ;_Ano____
        DB      20h,4Eh,65h,20h,20h,20h,20h,20h         ;_Ne_____
        DB      4Eh,61h,73h,74h,61h,76h,3Ah,20h         ;Nastav:_
        DB      20h,20h,20h,20h,20h,20h,20h,20h         ;________
        DB      44h,00h,6Ch,6Bh,61h,20h,20h,31h         ;Dlka__1
        DB      6Bh,72h,6Fh,6Bh,75h,20h,20h,20h         ;kroku___
        DB      44h,2Eh,6Bh,72h,6Fh,6Bh,75h,3Ah         ;D.kroku:
        DB      20h,20h,20h,20h,20h,20h,63h,6Dh         ;______cm
        DB      44h,61h,74h,61h,20h,6Bh,20h,32h         ;Data_k_2
        DB      76h,79h,73h,01h,6Ch,02h,6Eh,01h         ;vysln
        DB      5Ah,72h,79h,63h,68h,2Eh,20h,20h         ;Zrych.__
        DB      4Bh,72h,6Fh,6Bh,20h,20h,20h,20h         ;Krok____
        DB      4Bh,61h,6Ch,69h,62h,72h,2Eh,33h         ;Kalibr.3
        DB      20h,20h,20h,20h,20h,20h,20h,20h         ;________
        DB      50h,6Fh,6Ch,6Fh,03h,20h,6Eh,61h         ;Polo_na
        DB      73h,74h,72h,61h,6Eh,75h,20h,20h         ;stranu__
        DB      49h,6Eh,66h,6Fh,3Ah,20h,20h,20h         ;Info:___
        DB      20h,20h,20h,20h,20h,20h,20h,20h         ;________
        DB      56h,79h,70h,6Eh,6Fh,75h,74h,3Fh         ;Vypnout?
        DB      20h,20h,20h,20h,20h,20h,20h,20h         ;________
        DB      53h,6Dh,61h,7Ah,02h,6Eh,6Fh,21h         ;Smazno!
        DB      20h,20h,20h,20h,20h,20h,20h,20h         ;________
        DB      4Eh,61h,73h,74h,61h,76h,2Eh,20h         ;Nastav._
        DB      75h,6Ch,6Fh,03h,65h,6Eh,6Fh,21h         ;uloeno!

;---------------------------------------------------------------------------

	END
